VERSION 5.00
Begin VB.UserControl CharBox 
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   KeyPreview      =   -1  'True
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "CharBox.ctx":0000
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   870
      Top             =   2580
   End
   Begin VB.PictureBox picBackGround 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   ""
         Size            =   8.25
         Charset         =   134
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   705
      Left            =   405
      ScaleHeight     =   47
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   110
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   780
      Width           =   1650
   End
End
Attribute VB_Name = "CharBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private mText As String
Public Enum eBorderStyle
    [none] = 0
    [Fixed Single] = 1
End Enum
Private WithEvents StdScroll As StandardScroll
Attribute StdScroll.VB_VarHelpID = -1
Private tarr() As String
Private mDowned As Boolean
Dim oldMouseX As Single, oldMouseY As Single
Dim oldX As Long, oldY As Long
Dim curX As Long, curY As Long
Public Event Click(char As String)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event Captured()
Private mChar As String
Private mScrollLeft As Boolean, mScrollRight As Boolean, mScrollUp As Boolean, mScrollDown As Boolean
Private mEnabled As Boolean

Public Property Get BorderStyle() As eBorderStyle
BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal NewBorderStyle As eBorderStyle)
UserControl.BorderStyle = NewBorderStyle
End Property

Private Sub picBackGround_KeyDown(KeyCode As Integer, Shift As Integer)
UserControl_MouseMove 0, 0, -1, -1
End Sub

Private Sub picBackGround_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
RaiseEvent Captured
SetCapture UserControl.hWnd
'picBackGround.SetFocus
End Sub

Private Sub UserControl_DblClick()
mDowned = True
UserControl_MouseMove 0, 0, oldMouseX, oldMouseY
End Sub

Private Sub UserControl_Initialize()
Set StdScroll = New StandardScroll
StdScroll.Bind UserControl.hWnd
StdScroll.SetValue 0, SCROLL_HORZ
StdScroll.SetValue 0, SCROLL_VERT
UserControl.MouseIcon = LoadResPicture("curhand", vbResCursor)
mEnabled = True
End Sub

Private Sub UserControl_InitProperties()
BorderStyle = WithBorder
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
mDowned = True
UserControl_MouseMove Button, Shift, X, Y
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim tx As Long, ty As Long, t As Long, t1 As Long
'If Button = 0 Then

    With UserControl
        If X < .ScaleWidth And X > 0 And Y > 0 And Y < .ScaleHeight Then
            tx = (X - picBackGround.Left) \ 18
            ty = (Y - picBackGround.Top) \ 18
            HighLightCell tx, ty
        Else
            If Button = 0 Then
                HighLightCell -1, -1
                ReleaseCapture
                mDowned = False
            Else
                mChar = ""
                If X < 0 Then mScrollLeft = True: tx = -X
                If Y < 0 Then mScrollUp = True: ty = -Y
                If X > .ScaleWidth Then mScrollRight = True: tx = X - .ScaleWidth
                If Y > .ScaleHeight Then mScrollDown = True: ty = Y - .ScaleHeight
                If tx < ty Then
                    t = ty
                    t1 = Screen.Height / Screen.TwipsPerPixelY / 6
                Else
                    t = tx
                    t1 = Screen.Width / Screen.TwipsPerPixelX / 6
                End If
                t = 68 - (t * 68 / t1)
                If t < 5 Then t = 5
                Timer1.Interval = t
                'Debug.Print Timer1.Interval & "," & t & "," & t1 & " " & Now
                Timer1.Enabled = True
            End If
        End If
    End With
'End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
mDowned = False
UserControl_MouseMove Button, Shift, X, Y
oldMouseX = X
oldMouseY = Y
If mChar <> "" Then
    Dim tx As Long, ty As Long
    tx = oldX
    ty = oldY
    HighLightCell curX, curY
    curX = tx
    curY = ty
    HighLightCell curX, curY
    RaiseEvent Click(mChar)
Else
    HighLightCell -1, -1
End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
Text = PropBag.ReadProperty("Text", "")
End Sub

Private Sub UserControl_Resize()
Dim i As Long, CellWidth As Long, CellHeight As Long
CellWidth = ScaleWidth / 18
CellHeight = ScaleHeight / 18
For i = 0 To CellWidth
    UserControl.Line (i * 18, 0)-(i * 18, CellHeight * 18), vbBlack
Next i
For i = 0 To CellHeight
    UserControl.Line (0, i * 18)-(CellWidth * 18, i * 18), vbBlack
Next i
UpdateScrollbars
End Sub

Private Sub UserControl_Show()
On Error Resume Next
'picBackGround.SetFocus
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
PropBag.WriteProperty "BorderStyle", UserControl.BorderStyle
PropBag.WriteProperty "Text", mText
End Sub

Private Sub RedrawBox()
Dim tx As Long, ty As Long, t As Long, i As Long, j As Long, ct As Long
Dim CellWidth As Long, CellHeight As Long
tarr = Split(Replace(mText, vbCrLf, vbLf), vbLf)
CellHeight = UBound(tarr) + 1
ct = 0
For i = 0 To CellHeight - 1
    t = Len(tarr(i))
    If t > ct Then ct = t
Next i
CellWidth = ct
Debug.Print CellWidth & "," & CellHeight
With picBackGround
    .Cls
    .FontSize = 9
    't = 18 * CellWidth+1
    'If t > 18 Then t = t + 1
    .Move 0, 0, 18 * CellWidth + 1, 18 * CellHeight + 1
    For i = 0 To CellWidth
        picBackGround.Line (i * 18, 0)-(i * 18, CellHeight * 18), vbBlack
    Next i
    For i = 0 To CellHeight
        picBackGround.Line (0, i * 18)-(CellWidth * 18, i * 18), vbBlack
    Next i
    For i = 0 To CellWidth
        For j = 0 To CellHeight - 1
            .CurrentX = i * 18 + 4
            .CurrentY = j * 18 + 4
            picBackGround.Print Mid(tarr(j), i + 1, 1)
        Next j
    Next i
End With
UpdateScrollbars
'Debug.Print ScaleHeight & "-" & picBackGround.ScaleHeight
End Sub

Private Sub UpdateScrollbars()
On Error Resume Next
Static Updating As Boolean, t As Long
If Updating Then Exit Sub
Updating = True
t = (picBackGround.ScaleWidth - UserControl.ScaleWidth - 1) \ 18 '+ IIf((t*18<picbackground.ScaleHeight , 1, 0)
If t * 18 + UserControl.ScaleWidth < picBackGround.ScaleWidth Then t = t + 1
StdScroll.SetInfo t, UserControl.ScaleWidth \ 18, SCROLL_HORZ
t = (picBackGround.ScaleHeight - UserControl.ScaleHeight) \ 18
If t * 18 + UserControl.ScaleHeight < picBackGround.ScaleHeight Then t = t + 1
StdScroll.SetInfo t, UserControl.ScaleHeight \ 18, SCROLL_VERT
Updating = False
picBackGround.Move -StdScroll.HValue * 18, -StdScroll.VValue * 18
End Sub

Public Property Get Text() As String
Text = mText
End Property

Public Property Let Text(ByVal NewText As String)
mText = NewText
curX = -1
curY = -1
RedrawBox
End Property

Private Sub stdScroll_HChange(ByVal Value As Long)
picBackGround.Move -Value * 18
End Sub

Private Sub stdScroll_VChange(ByVal Value As Long)
picBackGround.Top = -Value * 18
End Sub

Public Property Get SW() As Long
SW = ScaleWidth
End Property

Private Sub HighLightCell(X As Long, Y As Long)
On Error Resume Next
Dim c As String
UserControl.MousePointer = 0
If oldX = curX And oldY = curY Then
    picBackGround.Line (oldX * 18 + 2, oldY * 18 + 2)-(oldX * 18 + 16, oldY * 18 + 16), vbBlue, BF
    picBackGround.CurrentX = oldX * 18 + 4
    picBackGround.CurrentY = oldY * 18 + 4
    picBackGround.ForeColor = vbWhite
    picBackGround.Print Mid(tarr(oldY), oldX + 1, 1)
Else
    picBackGround.Line (oldX * 18 + 1, oldY * 18 + 2)-(oldX * 18 + 16, oldY * 18 + 16), vbWindowBackground, BF
    picBackGround.CurrentX = oldX * 18 + 4
    picBackGround.CurrentY = oldY * 18 + 4
    picBackGround.ForeColor = vbWindowText
    picBackGround.Print Mid(tarr(oldY), oldX + 1, 1)
End If
mChar = ""
mChar = Trim(Mid(tarr(Y), X + 1, 1))
If mChar <> "" Then
    picBackGround.Line (X * 18 + 2, Y * 18 + 2)-(X * 18 + 16, Y * 18 + 16), IIf(mDowned, vbMagenta, vbYellow), BF
    picBackGround.CurrentX = X * 18 + 4
    picBackGround.CurrentY = Y * 18 + 4
    picBackGround.ForeColor = IIf(mDowned, vbWhite, vbBlack)
    picBackGround.Print mChar
    UserControl.MousePointer = 99
End If
oldX = X
oldY = Y
End Sub

Private Sub Timer1_Timer()
If mScrollLeft Or mScrollRight Or mScrollUp Or mScrollDown Then Timer1.Enabled = False
If mScrollLeft Then SendMessage UserControl.hWnd, WM_HSCROLL, MakeWord(SB_LINELEFT, 0), 0: mScrollLeft = False
If mScrollUp Then SendMessage UserControl.hWnd, WM_VSCROLL, MakeWord(SB_LINEUP, 0), 0: mScrollUp = False
If mScrollRight Then SendMessage UserControl.hWnd, WM_HSCROLL, MakeWord(SB_LINERIGHT, 0), 0: mScrollRight = False
If mScrollDown Then SendMessage UserControl.hWnd, WM_VSCROLL, MakeWord(SB_LINEDOWN, 0), 0: mScrollDown = False
End Sub

Public Property Get hWnd() As Long
hWnd = UserControl.hWnd
End Property

Public Property Let Enabled(ByVal NewEnabled As Boolean)
mEnabled = NewEnabled
UserControl.Enabled = mEnabled
End Property
