VERSION 5.00
Begin VB.Form frmCmdlg 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Cmdlg Class Example by: Wpsjr1.syix.com"
   ClientHeight    =   3015
   ClientLeft      =   30
   ClientTop       =   315
   ClientWidth     =   5610
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3015
   ScaleWidth      =   5610
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkMultiSelect 
      Caption         =   "Open MultiSelect"
      Height          =   252
      Left            =   3000
      TabIndex        =   12
      Top             =   1440
      Width           =   2052
   End
   Begin VB.ListBox lstMulti 
      Height          =   450
      Left            =   1440
      TabIndex        =   10
      Top             =   2160
      Width           =   3612
   End
   Begin VB.TextBox txt 
      Enabled         =   0   'False
      Height          =   288
      Index           =   3
      Left            =   1440
      TabIndex        =   5
      Top             =   1680
      Width           =   852
   End
   Begin VB.TextBox txt 
      Enabled         =   0   'False
      Height          =   288
      Index           =   2
      Left            =   1440
      TabIndex        =   4
      Top             =   1200
      Width           =   852
   End
   Begin VB.TextBox txt 
      Enabled         =   0   'False
      Height          =   288
      Index           =   1
      Left            =   1440
      TabIndex        =   3
      Top             =   720
      Width           =   3612
   End
   Begin VB.TextBox txt 
      Enabled         =   0   'False
      Height          =   288
      Index           =   0
      Left            =   1440
      TabIndex        =   2
      Top             =   240
      Width           =   3612
   End
   Begin VB.CommandButton cmdShowSave 
      Caption         =   "ShowSave"
      Height          =   288
      Left            =   2520
      TabIndex        =   1
      Top             =   1080
      Width           =   2532
   End
   Begin VB.CommandButton cmdShowOpen 
      Caption         =   "ShowOpen"
      Height          =   288
      Left            =   2520
      TabIndex        =   0
      Top             =   1800
      Width           =   2532
   End
   Begin VB.Label lbl5 
      Alignment       =   1  'Right Justify
      Height          =   492
      Left            =   120
      TabIndex        =   11
      Top             =   2280
      Width           =   1212
   End
   Begin VB.Label lbl4 
      Alignment       =   1  'Right Justify
      Caption         =   "Cancel Pressed: "
      Height          =   252
      Left            =   120
      TabIndex        =   9
      Top             =   1720
      Width           =   1212
   End
   Begin VB.Label lbl3 
      Alignment       =   1  'Right Justify
      Caption         =   "Extension: "
      Height          =   252
      Left            =   120
      TabIndex        =   8
      Top             =   1240
      Width           =   1212
   End
   Begin VB.Label lbl2 
      Alignment       =   1  'Right Justify
      Caption         =   "FileTitle: "
      Height          =   252
      Left            =   240
      TabIndex        =   7
      Top             =   760
      Width           =   1092
   End
   Begin VB.Label lbl1 
      Alignment       =   1  'Right Justify
      Caption         =   "Filename: "
      Height          =   252
      Left            =   120
      TabIndex        =   6
      Top             =   280
      Width           =   1212
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "popup"
      Visible         =   0   'False
      Begin VB.Menu mnuAbout 
         Caption         =   "&About"
         Shortcut        =   ^A
      End
   End
End
Attribute VB_Name = "frmCmdlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' I wish to thank the people at VBnet for posting the code to open
' and save, allowing directly access the cmdlg32.dll
' their URL is:
' http://home.sprynet.com/sprynet/rasanen/vbnet/default.htm

' I wrote this class module to mirror the properties of the CommonDialog
' control.  The OCX is fine but why waste the bandwidth distributing it.

' I did add a property to return the extension of the filename.
' You may use the CancelPressed property to perform events normally
' generated by the CancelError property of the CommonDialog control.
' Mutiple selections are also supported.

Dim cdl As New Cmdlg                      ' initialize a new instance of the Class
'

' ------------------  the easy way -------------------------------
' I know this may look a bit complicated, but if you want a simple
' open dialog just do the following:

' Dim cdl as New Cmdlg
' cdl.ShowOpen or cdl.ShowSave
' the filename will be contained in cdl.Filename
' -----------------------------------------------------------------

Private Sub cmdShowOpen_Click()

  Call ClearTextBoxes
  lstMulti.Clear

  ' the filter entries must be seperated by nulls and terminated with two nulls
  cdl.Filter = "any stuff (*.*)" & Chr(0) & "*.*" & Chr(0) & "stuff (*.bas)" _
  & Chr(0) & "*.bas" & Chr(0) & "more stuff (*.exe)" & Chr(0) & "*.exe" & Chr(0) & Chr(0)
  
  cdl.FileName = ""                       ' previous filename will appear in the combo if not set to the empty string
  cdl.FilterIndex = 2                     ' defaults to 1 if not set
  cdl.DefaultExtension = "*.txt"          ' if the user omits the extension the DefaultExtenstion will be used
  cdl.DialogTitle = "Open"                ' title of the dialog
  cdl.hWnd = Me.hWnd                      ' the dialog will not be modal unless a hWnd is specified.
  cdl.InitDir = "c:\program files"        ' initial directory opened
  
  If chkMultiSelect.Value = 0 Then
    cdl.Flags = StandardFlag.OpenFile     ' not multiselect
  Else
    cdl.Flags = StandardFlag.OpenMulti    ' multiselect flag
  End If

  cdl.ShowOpen                            ' Opens the dialog
 
  txt(0).Text = cdl.FileName              ' the filename returned
  txt(1).Text = cdl.Filetitle             ' the filetitle returned
  txt(2).Text = cdl.FileExtension         ' the fileextension returned
  txt(3).Text = cdl.CancelPressed

  If cdl.MultiSelect = True Then
    Call ParseNulls(cdl.FileName)
  End If
End Sub


Private Sub cmdShowSave_Click()

  Call ClearTextBoxes
  lstMulti.Clear

  cdl.Filter = "any stuff (*.*)" & Chr(0) & "*.*" & Chr(0) & "stuff (*.bas)" & Chr(0) & "*.bas" & Chr(0) & "more stuff (*.exe)" & Chr(0) & "*.exe" & Chr(0) & Chr(0)
  cdl.FilterIndex = 2
  cdl.FileName = ""
  cdl.DefaultExtension = "*.txt"
  cdl.DialogTitle = "Save As"
  cdl.hWnd = Me.hWnd
  cdl.InitDir = "c:\program files"
  cdl.Flags = StandardFlag.SaveFile
  cdl.ShowSave

  txt(0).Text = cdl.FileName
  txt(1).Text = cdl.Filetitle
  txt(2).Text = cdl.FileExtension
  txt(3).Text = cdl.CancelPressed

End Sub

Private Sub ParseNulls(sFilename As String)
Dim i%, sPath$

    i = InStr(sFilename, Chr(0))           ' find the first null
    sPath = Left$(sFilename, i - 1)        ' extract the path
    sFilename = Mid$(sFilename, i + 1)     ' remove the path and first null
    txt(1).Text = "Multiple files selected"

    Do                                     ' thanks Dan :)
      i = InStr(sFilename, Chr$(0))        ' find the first null
        If i > 1 Then                      ' if a null is found
          lstMulti.AddItem IIf(Right$(sPath, 1) = "\", sPath & Left$(sFilename, i - 1), sPath & "\" & Left$(sFilename, i - 1))
          sFilename = Mid$(sFilename, i + 1) ' remove what was just extracted
        End If
      DoEvents
    Loop Until i <= 1                      ' continue until there are no more nulls
  
End Sub

Private Sub ClearTextBoxes()

  Dim i%
  For i = 0 To 3                           ' loop through the TextBoxes and clear them
    txt(i).Text = ""
  Next i

End Sub

Private Sub Form_Load()
lbl5.Caption = "Multiple" & vbCrLf & "files:"
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = 2 Then PopupMenu Me.mnuPopup   ' show the popupmenu on right-click
End Sub

Private Sub Form_Unload(Cancel As Integer)

  Set cdl = Nothing                        ' cleanup

End Sub


Private Sub mnuAbout_Click()
frmAbout.Show 1                            ' show as modal
End Sub
