VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EditStep"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private mCellDatas() As CellData
Private mCellUbound As Long
Private mCursorX As Long, mCursorY As Long

Public Sub SaveCursorPos(x As Long, y As Long)
mCursorX = x
mCursorY = y
End Sub

Public Sub AddCell(x As Long, y As Long)
On Error Resume Next
mCellUbound = mCellUbound + 1
ReDim Preserve mCellDatas(mCellUbound)
With mCellDatas(mCellUbound)
    CopyMemory .Cell, mCells(x, y), 24&
    .Char = mChars(x, y)
    .x = x
    .y = y
End With
End Sub

Public Sub AddCells(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long)
Dim x As Long, y As Long, mct As Long, ct As Long
mct = mCellUbound + (X2 - X1 + 1) * (Y2 - Y1 + 1)
ReDim Preserve mCellDatas(mct)
For y = Y1 To Y2
    For x = X1 To X2
        ct = ct + 1
        With mCellDatas(mCellUbound + ct)
            CopyMemory .Cell, mCells(x, y), 24&
            .Char = mChars(x, y)
            .x = x
            .y = y
        End With
    Next x
Next y
mCellUbound = mct
End Sub

Private Sub Class_Initialize()
mCellUbound = -1
End Sub

Friend Sub Restore()
On Error Resume Next
Dim i As Long, t As Long, x As Long, y As Long
Dim tx As Long, ty As Long, tCellDatas() As CellData
tx = mX
ty = mY
t = UBound(mCellDatas)
ReDim tCellDatas(t)
CopyMemory tCellDatas(0), mCellDatas(0), (t + 1) * 36&
For i = 0 To t
    With tCellDatas(i)
        x = .x
        y = .y
        CopyMemory .Cell, mCells(x, y), 24&
        .Char = mChars(x, y)
    End With
Next i
For i = t To 0 Step -1
    With mCellDatas(i)
        x = .x
        y = .y
        CopyMemory mCells(x, y), .Cell, 24&
        mChars(x, y) = .Char
    End With
Next i
CopyMemory mCellDatas(0), tCellDatas(0), (t + 1) * 36&
mX = mCursorX
mY = mCursorY
mCursorX = tx
mCursorY = ty
End Sub

Public Property Get IsEmpty() As Boolean
IsEmpty = (mCellUbound = -1)
End Property
