VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StandardScroll"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'------
'-------
Implements ISubclass
Private m_emr As EMsgResponse
Public Enum eDir
    SCROLL_HORZ = 0
    SCROLL_VERT = 1
End Enum
Public Event VChange(ByVal Value As Long)
Public Event HChange(ByVal Value As Long)
Dim BindHwnd As Long
Dim yPos As Long, xPos As Long
Dim vmMax As Long, vmMin As Long, hmMax As Long, hmMin As Long

Private Sub Class_Terminate()
DetachMessage Me, BindHwnd, WM_VSCROLL
DetachMessage Me, BindHwnd, WM_HSCROLL
End Sub

Private Property Let ISubclass_MsgResponse(ByVal RHS As EMsgResponse)
'
End Property

Private Property Get ISubclass_MsgResponse() As EMsgResponse
'
End Property

'----------------------------------- Interface -----------------------------
Public Function Bind(ByVal hWnd As Long)
Dim style As Long, wl As Long
BindHwnd = hWnd
Dim si As SCROLLINFO
With si
    .cbSize = LenB(si)
    .fMask = SIF_ALL
    .nMin = 0
    .nMax = 100 + (30 - 1)
    .nPage = 30
    .nPos = 0
    .nTrackPos = 0
End With
vmMax = 100: hmMax = 100
SetScrollInfo BindHwnd, SB_VERT, si, ByVal True
SetScrollInfo BindHwnd, SB_HORZ, si, ByVal True
SetWindowPos BindHwnd, 0, 0, 0, 0, 0, 39&
AttachMessage Me, BindHwnd, WM_VSCROLL
AttachMessage Me, BindHwnd, WM_HSCROLL
AttachMessage Me, BindHwnd, WM_MOUSEWHEEL
End Function

Public Sub SetInfo(Optional ByVal nMax As Long = -1, Optional ByVal nPage As Long = -1, Optional vDir As eDir = SCROLL_VERT)
Dim si As SCROLLINFO
si.cbSize = LenB(si)
si.fMask = SIF_ALL
GetScrollInfo BindHwnd, vDir, si
'If nMax <> -1 Then
    If vDir = SB_VERT Then
        vmMax = nMax
        'si.nPos = yPos
    Else
        hmMax = nMax
        'si.nPos = xPos
    End If
    si.nMax = nMax
'End If
If nPage <> -1 Then si.nPage = nPage Else nPage = si.nPage
si.nMax = nMax + nPage - 1
SetScrollInfo BindHwnd, vDir, si, ByVal True
GetScrollInfo BindHwnd, vDir, si
If nMax > 0 Then
    If vDir = SCROLL_HORZ Then xPos = si.nPos Else yPos = si.nPos
End If
End Sub

Public Sub SetValue(ByVal vNewValue As Long, Optional vDir As eDir = SCROLL_VERT)
Dim si As SCROLLINFO
If vDir = SCROLL_VERT Then yPos = vNewValue Else xPos = vNewValue
si.cbSize = LenB(si)
si.fMask = SIF_ALL
GetScrollInfo BindHwnd, vDir, si
si.nPos = vNewValue
SetScrollInfo BindHwnd, vDir, si, ByVal True
'If vDir = SCROLL_HORZ Then RaiseEvent HChange(vNewValue) Else RaiseEvent VChange(1)
If vDir = SCROLL_VERT Then
    RaiseEvent VChange(vNewValue)
Else
    RaiseEvent HChange(vNewValue)
End If
End Sub

Public Sub SetVisible(Visible As Boolean, Optional vDir As eDir = SCROLL_VERT)
Dim si As SCROLLINFO
si.cbSize = LenB(si)
si.fMask = SIF_ALL
GetScrollInfo BindHwnd, vDir, si
If Visible Then
    If vDir = SB_VERT Then si.nMax = vmMax Else si.nMax = hmMax
Else
    si.nMax = -1
End If
SetScrollInfo BindHwnd, vDir, si, ByVal True
End Sub

'--------
Public Property Get VValue() As Long
VValue = yPos
End Property

Public Property Get HValue() As Long
HValue = xPos
End Property

Public Property Get vMax() As Long
vMax = vmMax
End Property

Public Property Get HMax() As Long
HMax = hmMax
End Property
'-----------------
Private Function ISubClass_WindowProc(ByVal hWnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim yInc As Long, xInc As Long
Dim si As SCROLLINFO
Select Case iMsg
    Case WM_VSCROLL
        si.cbSize = LenB(si)
        si.fMask = SIF_ALL
        GetScrollInfo hWnd, SB_VERT, si
        yPos = si.nPos
        Select Case LoWord(wParam)
            Case SB_PAGEUP:
                 yInc = -si.nPage
            Case SB_PAGEDOWN:
                 yInc = si.nPage
            Case SB_LINEUP:
                 yInc = -1
            Case SB_LINEDOWN:
                 yInc = 1
            Case SB_THUMBTRACK
                yPos = si.nTrackPos: GoTo jmp
        End Select
        yInc = MaxVal(-yPos, MinVal(yInc, si.nMax - yPos))
        If yInc Then
jmp:
            yPos = yPos + yInc
            If yPos > vmMax Then yPos = vmMax
            si.fMask = SIF_POS
            si.nPos = yPos
            SetScrollInfo hWnd, SB_VERT, si, True
            RaiseEvent VChange(yPos)
        End If
    Case WM_HSCROLL
        si.cbSize = LenB(si)
        si.fMask = SIF_ALL
        GetScrollInfo hWnd, SB_HORZ, si
        xPos = si.nPos
        Select Case LoWord(wParam)
            Case SB_PAGELEFT:
                 xInc = -si.nPage
            Case SB_PAGERIGHT:
                 xInc = si.nPage
            Case SB_LINELEFT:
                 xInc = -1 '* 30
            Case SB_LINERIGHT:
                 xInc = 1 '* 30
            Case SB_THUMBTRACK
                xPos = si.nTrackPos: GoTo jmp1
        End Select
        xInc = MaxVal(-xPos, MinVal(xInc, si.nMax - xPos))
        If xInc Then
jmp1:
            xPos = xPos + xInc
            If xPos > hmMax Then xPos = hmMax
            si.fMask = SIF_POS
            si.nPos = xPos
            SetScrollInfo hWnd, SB_HORZ, si, True
            RaiseEvent HChange(xPos)
        End If
    Case WM_MOUSEWHEEL
        Dim adj As Integer
        If HiWord(wParam) > 0 Then adj = -1 Else adj = 1
        si.cbSize = LenB(si)
        si.fMask = SIF_ALL
        GetScrollInfo hWnd, SB_VERT, si
        yPos = si.nPos
        yPos = yPos + 2 * adj
        If yPos > vmMax Then
            yPos = vmMax
        ElseIf yPos < 0 Then
            yPos = 0
        End If
        si.fMask = SIF_POS
        si.nPos = yPos
        SetScrollInfo hWnd, SB_VERT, si, True
        RaiseEvent VChange(yPos)
End Select
End Function

Public Sub Detach()
   If Not BindHwnd = 0 Then
        DetachMessage Me, BindHwnd, WM_VSCROLL
        DetachMessage Me, BindHwnd, WM_HSCROLL
        DetachMessage Me, BindHwnd, WM_MOUSEWHEEL
   End If
End Sub

Private Function MaxVal(v1, v2)
MaxVal = IIf(v1 > v2, v1, v2)
End Function

Private Function MinVal(v1, v2)
MinVal = IIf(v1 < v2, v1, v2)
End Function

Private Function LoWord(ByVal dw As Long) As Integer
CopyMemory LoWord, dw, 2
End Function

Private Function HiWord(ByVal dw As Long) As Integer
CopyMemory HiWord, ByVal VarPtr(dw) + 2, 2
End Function

Private Function MakeWord(ByVal LoWord As Integer, HiWord As Integer) As Long
Dim WordArr(0 To 1) As Integer
WordArr(0) = LoWord
WordArr(1) = HiWord
CopyMemory MakeWord, ByVal VarPtr(WordArr(0)), 4
End Function


