Attribute VB_Name = "modCommonDlg"
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Long
    nFileExtension As Long
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Public Const CC_RGBINIT         As Long = &H1
Public Const CC_FULLOPEN        As Long = &H2
Public Const CC_PREVENTFULLOPEN As Long = &H4
Public Const CC_SOLIDCOLOR      As Long = &H80
Public Const CC_ANYCOLOR        As Long = &H100
Public dwCustClrs(0 To 15) As Long
Public Type CHOOSECOLORSTRUCT
   lStructSize     As Long
   hwndOwner       As Long
   hInstance       As Long
   rgbResult       As Long
   lpCustColors    As Long
   Flags           As Long
   lCustData       As Long
   lpfnHook        As Long
   lpTemplateName  As String
End Type

Public Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (lpcc As CHOOSECOLORSTRUCT) As Long

Private Sub GetRBGFromCLRREF(ByVal clrref As Long, r As Long, g As Long, b As Long)
'pass a hex colour, return the rgb components
b = (clrref \ 65536) And &HFF
g = (clrref \ 256) And &HFF
r = clrref And &HFF
End Sub

Public Function ShowChooseColor(Optional InitColor As Long = -1, Optional OwnerHwnd As Long) As Long
Dim cc As CHOOSECOLORSTRUCT
With cc
   .Flags = CC_ANYCOLOR
   If InitColor <> -1 Then
      .Flags = .Flags Or CC_RGBINIT
      .rgbResult = InitColor
   End If
   .lStructSize = Len(cc)
   .hwndOwner = OwnerHwnd
   .lpCustColors = VarPtr(dwCustClrs(0))
End With

If ChooseColor(cc) = 1 Then
   ShowChooseColor = cc.rgbResult
Else
    ShowChooseColor = -1
End If
End Function
