Attribute VB_Name = "modstatusbar"
Public Declare Function CreateStatusWindow Lib "comctl32" Alias "CreateStatusWindowA" (ByVal style As Long, ByVal lpszText As String, ByVal hWndParent As Long, ByVal wID As Long) As Long
Public Const STATUSCLASSNAME As String = "msctls_statusbar32"
Public Const SBARS_SIZEGRIP As Long = &H100
Public Const WS_VISIBLE As Long = &H10000000
Public Const WS_CHILD As Long = &H40000000
Public Declare Sub DrawStatusText Lib "comctl32" Alias "DrawStatusTextA" (ByVal hDC As Long, lprc As RECT, ByVal pszText As Long, uFlags As Long)
Public Const SBT_SUNKEN As Long = &H0 'Default
Public Const SBT_NOBORDERS As Long = &H100
Public Const SBT_POPOUT As Long = &H200
Public Const SBT_RTLREADING As Long = &H400
Public Const SBT_OWNERDRAW As Long = &H1000
Public Const WM_USER As Long = &H400
Public Const SB_SETTEXT As Long = (WM_USER + 1)
Public Const sbSimpleIdx As Long = 255
Public Const SB_GETTEXT As Long = (WM_USER + 2)
Public Const SB_GETTEXTLENGTH As Long = (WM_USER + 3)
Public Const SB_SETPARTS As Long = (WM_USER + 4)
Public Const SB_GETPARTS As Long = (WM_USER + 6)
Public Const SB_GETBORDERS As Long = (WM_USER + 7)
Public Const SBB_HORIZONTAL As Long = 0 'horz border width
Public Const SBB_VERTICAL As Long = 1 'vert border width
Public Const SBB_DIVIDER As Long = 2 'vert part divider width
Public Const SB_SETMINHEIGHT As Long = (WM_USER + 8)
Public Const SB_SIMPLE As Long = (WM_USER + 9)
Public Const SB_GETRECT As Long = (WM_USER + 10)
Public Const SB_ISSIMPLE As Long = (WM_USER + 14)
Public Const WM_CREATE As Long = &H1
Public Const WM_DESTROY As Long = &H2
Public Const WM_SIZE As Long = &H5
Public Const WM_SETTEXT As Long = &HC
Public Const WM_GETTEXT As Long = &HD
Public Const WM_GETTEXTLENGTH As Long = &HE
Public Const WM_PAINT As Long = &HF
Public Const WM_SETFONT As Long = &H30
Public Const WM_GETFONT = &H31
Public Const WM_NCHITTEST As Long = &H84
Public Const CCS_TOP As Long = &H1&
Public Const CCS_NOMOVEY As Long = &H2&
Public Const CCS_BOTTOM As Long = &H3&
Public Const CCS_NORESIZE As Long = &H4&
Public Const CCS_NOPARENTALIGN As Long = &H8&
Public Const CCS_NOHILITE As Long = &H10&
Public Const CCS_ADJUSTABLE As Long = &H20&
Public Const CCS_NODIVIDER As Long = &H40&

'---------------------------------------------------------------------
Public Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Public Declare Function InvalidateRect Lib "user32" (ByVal hWnd As Long, lpRect As Any, ByVal bErase As Long) As Long
'------------------------------------------------------------------------------
Public Const ICC_LISTVIEW_CLASSES = &H1 'listview, header
Public Const ICC_TREEVIEW_CLASSES = &H2 'treeview, tooltips
Public Const ICC_BAR_CLASSES = &H4 'toolbar, statusbar, trackbar, tooltips
Public Const ICC_TAB_CLASSES = &H8 'tab, tooltips
Public Const ICC_UPDOWN_CLASS = &H10 'updown
Public Const ICC_PROGRESS_CLASS = &H20 'progress
Public Const ICC_HOTKEY_CLASS = &H40 'hotkey
Public Const ICC_ANIMATE_CLASS = &H80 'animate
Public Const ICC_WIN95_CLASSES = &HFF 'loads everything above
Public Const ICC_DATE_CLASSES = &H100 'month picker, date picker, time picker, updown
Public Const ICC_USEREX_CLASSES = &H200 'ComboEx
Public Const ICC_COOL_CLASSES = &H400 'Rebar (coolbar) control
Public Declare Function InitCommonControlsEx Lib "comctl32" (lpInitCtrls As tagINITCOMMONCONTROLSEX) As Boolean

Public Function InitComctl32(dwFlags As Long) As Boolean
    Dim icc As tagINITCOMMONCONTROLSEX
    On Error GoTo Err_OldVersion
    icc.dwSize = Len(icc)
    icc.dwICC = dwFlags
    InitComctl32 = InitCommonControlsEx(icc)
    Exit Function
Err_OldVersion:
    InitCommonControls
End Function

Public Sub SetParts(frm As Form, hStatBar As Long, bParts As Byte) '1-255 max!
    ReDim adwparts(bParts - 1) As Long
    Dim bPart As Byte
    'For bPart = 1 To bParts - 1
        'adwParts(bPart - 1) = (frm.ScaleWidth \ bParts) * bPart
        'MsgBox (frm.ScaleWidth \ bParts) * bPart
    '    adwParts(bPart - 1) = (frm.ScaleWidth \ bParts) * bPart
    'Next
    'adwParts(0) = 600 'frm.ScaleWidth - 330
    'adwParts(1) = 600
    adwparts(0) = frm.ScaleWidth - 230
    If adwparts(0) < 260 Then
        adwparts(0) = 260
        adwparts(1) = 375
        adwparts(2) = frm.ScaleWidth
    Else
        adwparts(2) = frm.ScaleWidth '-1
        adwparts(1) = frm.ScaleWidth - 115
    End If
    'adwParts(bParts - 1) = -1
    
    'adwParts(0) = -1 'frm.ScaleWidth - 230
    SendMessage hStatBar, SB_SETPARTS, ByVal bParts, adwparts(0)
End Sub

Public Function GetParts(hStatBar As Long) As Long
    GetParts = SendMessage(hStatBar, SB_GETPARTS, 0, ByVal 0)
End Function
Public Sub SetText(hStatBar As Long, bPart As Byte, wNewDrawOp As Long, sText As String)
    Dim wCurDrawOp As Long
    wCurDrawOp = GetCurDrawOp(hStatBar, bPart, False)
    SendMessage hStatBar, SB_SETTEXT, ByVal bPart Or wNewDrawOp, ByVal sText
    If wCurDrawOp <> wNewDrawOp Then InvalidateRect hStatBar, ByVal 0, True
End Sub
Public Function GetCurDrawOp(hStatBar As Long, bPart As Byte, fRtnString As Boolean) As String
    Dim dwRtn As Long
    dwRtn = SendMessage(hStatBar, SB_GETTEXTLENGTH, ByVal bPart, 0)
    dwRtn = (dwRtn And &HFFFF0000) \ &HFFFF&
    If fRtnString Then
        Select Case dwRtn
            Case SBT_SUNKEN: GetCurDrawOp = "SBT_SUNKEN"
            Case SBT_NOBORDERS: GetCurDrawOp = "SBT_NOBORDERS"
            Case SBT_POPOUT: GetCurDrawOp = "SBT_POPOUT"
        End Select
    Else
        GetCurDrawOp = dwRtn
    End If
End Function

