VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CIniFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'ԣ
'    File    Ҫiniļ
'
'    SaveSetting "","","ֵ"        -> ֵ
'    GetSetting "",""                -> ؼֵ
'    GetSection "",""ֵ"         -> ȡüֵ
'    DeleteSection ""                    -> ɾһ
'-----------------------------------
' Ini File Functions Class
' Copyright (C) 1996, Jens Balchen
' Uses
' Exposes
'     Function GetSetting
'     Function SaveSetting
'     Function GetSection
' Comments
'--
Option Explicit
' Property for file to read
Public File As String
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal Appname As String, ByVal KeyName As Any, ByVal NewString As Any, ByVal FileName As String) As Long

Sub DeleteSection(ByVal Section As String)
    Dim retval As Long
    retval = WritePrivateProfileString(Section, 0&, "", File)
End Sub

Public Function SaveSetting(ByVal Section As String, ByVal Key As String, ByVal Value As String)
    Dim retval As Long
    SaveSetting = WritePrivateProfileString(Section$, Key$, Value$, File)
End Function

Public Function GetSetting(ByVal Section As String, ByVal KeyName As String, Optional ByVal Default As Variant = "") As String
    Dim retval As Long
    Dim t As String * 255
    Dim ts As String
   ' Get the value
   retval = GetPrivateProfileString(Section, KeyName, "", t, Len(t), File)
   ' If there is one, return it
   If retval > 0 Then
      'ts = StrConv(LeftB(StrConv(t, vbFromUnicode), retval), vbFromUnicode)
      ts = Left$(t, retval)
      ts = Replace(ts, vbNullChar, "")
   Else
      ts = Default
   End If
'   Debug.Print KeyName & "," & ts
   GetSetting = ts
End Function

Public Function GetSection(ByVal Section As String, KeyArray() As String) As Long
    Dim retval As Long
    ' Allocate space for return value
    Dim t As String * 2500
    Dim lastpointer As Long
    Dim nullpointer As Long
    Dim ArrayCount As Long
    Dim keystring As String
    ReDim KeyArray(0)
    ' Get the value
    retval = GetPrivateProfileString(Section, 0&, "", t, Len(t), File)
    ' If there is one, return it
    If retval > 0 Then
       ' Separate the keys and store them in the array
        nullpointer = InStr(t, Chr$(0))
        lastpointer = 1
        Do While (nullpointer <> 0 And nullpointer > lastpointer + 1)
            ' Extract key string
            keystring = Mid$(t, lastpointer, nullpointer - lastpointer)
            ' Now add to array
            ArrayCount = ArrayCount + 1
            ReDim Preserve KeyArray(ArrayCount)
            KeyArray(ArrayCount) = keystring
            ' Find next null
            lastpointer = nullpointer + 1
            nullpointer = InStr(nullpointer + 1, t, Chr$(0))
       Loop
    End If
    ' Return the number of array elements
    GetSection = ArrayCount
End Function
