Attribute VB_Name = "Module1"
Option Explicit

Public UsingCharForm As Boolean
Public Quitting As Boolean
Public Type CellType
    ForeGround As Long
    BackGround As Long
    HighLight As Long
    Reverse As Boolean
    Blink As Boolean
    UnderLine As Boolean
    FontIndex As Long
End Type
Public mChars(255, 25) As Byte
Public mCells(81, 25) As CellType
Public mSelectedCells(81, 25) As Boolean
Public mX As Long, mY As Long
Public Type CellData
    X As Long
    Y As Long
    Cell As CellType
    char As Byte
End Type
Public Enum HistoryState
    NoUndoHistory
    NoRedoHistory
    NoHistory
    InHistory
End Enum
Public Enum ToolType
    NoTool = 0
    StampTool = 1
    RubberTool = 2
    FloodTool = 3
    ColorPickerTool = 4
    FormatBrushTool = 5
End Enum
Public Enum eCopyTypeEnum
    ct_EscText
    ct_PlainText
    ct_Html
End Enum
Public Enum ePasteTypeEnum
    pt_PasteAll
    pt_PasteNoBackGround
    pt_PasteNoForeGround
    pt_PasteNoBackAndForeGround
End Enum
Public gCurTool As ToolType
Public gSelectAfterPaste As Boolean
Public gIntelTrans As Boolean
Public gShowGrid As Boolean
Public gInterLine As Boolean
Public gGridColor As Long
Public gGridStyle As Long
Public gInsertMode As Boolean
Public gLastChar As String
Public gIntelCharRight0(5) As String
Public gIntelCharRight1(5) As String
Public gIntelCharLeft0(5) As String
Public gIntelCharLeft1(5) As String
Public gIntelCharUp0(5) As String
Public gIntelCharUp1(5) As String
Public gIntelCharBelow0(5) As String
Public gIntelCharBelow1(5) As String

'Public Const vbGray As Long = 6316128 '8421504 'RGB(128, 128, 128)
'------------------------------------------------

Public Type POINTAPI
        X As Long
        Y As Long
End Type
Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Public Type WINDOWPOS
        hWnd As Long
        hWndInsertAfter As Long
        X As Long
        Y As Long
        cx As Long
        cy As Long
        Flags As Long
End Type
Public Type PAINTSTRUCT
        hDC As Long
        fErase As Long
        rcPaint As RECT
        fRestore As Long
        fIncUpdate As Long
        rgbReserved(32) As Byte
End Type

Public Const WM_NCACTIVATE = &H86
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Const SM_CXVSCROLL = 2
Public Const PS_DOT = 2                     '  .......
Public Const DT_CENTER = &H1
Public Const DT_VCENTER = &H4
Public Const DT_SINGLELINE = &H20

Public Const VK_CONTROL = &H11
Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Public Declare Function BeginPaint Lib "user32" (ByVal hWnd As Long, lpPaint As PAINTSTRUCT) As Long
Public Declare Function EndPaint Lib "user32" (ByVal hWnd As Long, lpPaint As PAINTSTRUCT) As Long
Public Declare Function GetUpdateRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT, ByVal bErase As Long) As Long
Public Const WM_PAINT = &HF
Public Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Const SWP_NOZORDER = &H4
'-----
Public Declare Function MakeSureDirectoryPathExists Lib "IMAGEHLP" (ByVal lpString As String) As Long
'-----
Public Const SW_SHOW = 5
Public Const SW_SHOWMAXIMIZED = 3
Public Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
'---------
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Public Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
'--
Public Declare Sub InitCommonControls Lib "comctl32.dll" ()
Public Type tagINITCOMMONCONTROLSEX
    dwSize As Long
    dwICC As Long
End Type
Public Declare Function InitCommonControlsEx Lib "comctl32.dll" (lpInitCtrls As tagINITCOMMONCONTROLSEX) As Boolean
Public Const WM_SETTEXT = &HC
Public Const EM_LIMITTEXT = &HC5
'---------
Public Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Public Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long
Public Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function GetCurrentObject Lib "gdi32" (ByVal hDC As Long, ByVal uObjectType As Long) As Long
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Public Declare Function SetBkMode Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function ScrollWindow Lib "user32" (ByVal hWnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, lpRect As RECT, lpClipRect As RECT) As Long
Public Declare Function ScrollWindowA Lib "user32" Alias "ScrollWindow" (ByVal hWnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, ByVal lpRect As Long, ByVal lpClipRect As Long) As Long
Public Declare Function ScrollWindowB Lib "user32" Alias "ScrollWindowEx" (ByVal hWnd As Long, ByVal dx As Long, ByVal dy As Long, ByVal lprcScroll As Long, ByVal lprcClip As Long, ByVal hrgnUpdate As Long, ByVal lprcUpdate As Long, ByVal fuScroll As Long) As Long
Public Declare Function RedrawWindow Lib "user32" (ByVal hWnd As Long, ByVal lprcUpdate As Long, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function GetClipCursor Lib "user32" (lprc As RECT) As Long
Public Declare Function DrawState Lib "user32" Alias "DrawStateA" (ByVal hDC As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As Long, ByVal wParam As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal n3 As Long, ByVal n4 As Long, ByVal un As Long) As Long
Public Const DSS_DISABLED = &H20
Public Const DST_ICON = &H3
Public Const WM_WINDOWPOSCHANGED = &H47
Public Declare Function SetROP2 Lib "gdi32" (ByVal hDC As Long, ByVal nDrawMode As Long) As Long
Public Declare Function InvertRect Lib "user32" (ByVal hDC As Long, lpRect As RECT) As Long
Public Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Public Declare Function OleTranslateColor Lib "oleaut32" (ByVal clr As OLE_COLOR, ByVal hPal As Long, dwRGB As Long) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Sub FillMemory Lib "kernel32.dll" Alias "RtlFillMemory" (Destination As Any, ByVal Length As Long, ByVal Fill As Byte)
Public Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)
Public Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)
Public Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
Public Const SPI_GETWORKAREA = 48
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_NOMOVE = &H2
Public Const SWP_SHOWWINDOW = &H40
Public Const SWP_HIDEWINDOW = &H80
Public Const SM_CYSMCAPTION = 51&
Public Const VK_LBUTTON = &H1
Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Const WM_NCLBUTTONUP = &HA2
Public Const WM_NCLBUTTONDBLCLK = &HA3
Public Const WM_NCLBUTTONDOWN = &HA1



Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function SetBitmapDimensionEx Lib "gdi32" (ByVal hbm As Long, ByVal nX As Long, ByVal nY As Long, ByVal lpSize As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Const WM_CONTEXTMENU = &H7B&
Public Const WM_ACTIVATE = &H6
Public Const WM_MOUSEWHEEL = &H20A
'------------
Public Declare Function DrawIcon Lib "user32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal hIcon As Long) As Long
Public Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Public Const BDR_RAISEDINNER = &H4
Public Const BF_SOFT = &H1000     ' Use for softer buttons.
Public Const BF_LEFT = &H1
Public Const BF_TOP = &H2
Public Const BF_RIGHT = &H4
Public Const BF_BOTTOM = &H8
Public Const BDR_SUNKENOUTER = &H2
Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

Public Declare Function Rectangle Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Public Enum InputInfoType
    UrlInfo
    MsgInfo
    InputInfo
    ElseInfo
End Enum

'Public Declare Function ScrollDC Lib "user32" (ByVal hdc As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, lprcClip As RECT, ByVal hrgnUpdate As Long, lprcUpdate As RECT) As Long
Public Declare Function ScrollDC Lib "user32" (ByVal hDC As Long, ByVal dx As Long, ByVal dy As Long, ByVal lprcScroll As Long, ByVal lprcClip As Long, ByVal hrgnUpdate As Long, ByVal lprcUpdate As Long) As Long
Public Declare Function ScrollDCA Lib "user32" Alias "ScrollDC" (ByVal hDC As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, ByVal lprcClip As Long, ByVal hrgnUpdate As Long, ByVal lprcUpdate As Long) As Long

Public Declare Function CreateCaret Lib "user32" (ByVal hWnd As Long, ByVal hBitmap As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function DestroyCaret Lib "user32" () As Long
Public Declare Function SetCaretPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function ShowCaret Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function HideCaret Lib "user32" (ByVal hWnd As Long) As Long

Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long

Public Type LogFont
   lfHeight As Long
   lfWidth As Long
   lfEscapement As Long
   lfOrientation As Long
   lfWeight As Long
   lfItalic As Byte
   lfUnderline As Byte
   lfStrikeOut As Byte
   lfCharSet As Byte
   lfOutPrecision As Byte
   lfClipPrecision As Byte
   lfQuality As Byte
   lfPitchAndFamily As Byte
   lfFaceName As String * 32
End Type
Public Const OEM_CHARSET = 255
Public Const CLIP_DEFAULT_PRECIS = 0
Public Const PROOF_QUALITY = 2
Public Const OUT_DEFAULT_PRECIS = 0
Public Const OBJ_FONT = 6

Public Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LogFont) As Long
Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Public Declare Function MoveTo Lib "gdi32" Alias "MoveToEx" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpPoint As Long) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long

Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hinst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Public Declare Function DrawIconEx Lib "user32" (ByVal hDC As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long

Public gIni As New CIniFile
Public gBufferLeft() As Byte
Public sepchar8 As String
Public gColors(15) As Long
Public gHtmlColors(15) As String
Public gFontNames(0 To 3) As String
Public Type tFontInfo
    FontSize As Single
    BoxWidth As Long
    BoxHeight As Long
End Type
Public FontInfos(1 To 13) As tFontInfo
Public gcCursors As Collection
Public gTypeSet As Boolean, gCharsPerLine As Long, gUpdateTextBoxWhenDownFile As Boolean
Public gsRetVal As String
Public gUserId As String
Public gDataDealed As Boolean
Public gMouseEnabled As Boolean
Public gCopyHtml As Boolean
Public gDownloading As Boolean
Public gForceGoOn As Boolean
Public gQuitting As Boolean

Public Enum eBbsState
    bbsViewMenu = 1
    bbsViewBoards = 2
    bbsViewBoard = 3
    bbsViewAnnounce = 4
    bbsViewingPost = 5
    bbsViewPostDone = 6
    bbsPostTitleToEnter = 7
    bbsWritingPost = 8
    bbsPressAnyKey = 9
    bbsStateUnknown = 10
    bbsLeaving = 11
    bbsPressEnter = 12
    bbsMessageCome = 13
    bbsResetState = 14
    bbsMailList = 15
    bbsDisconnected = 16
End Enum
Public curBbsState As eBbsState
Public BytesDownload As Long, BytesUpload As Long, ConnectTime As Date

Public Function LoWord(dwValue As Long) As Long
  MoveMemory LoWord, dwValue, 2
End Function

Public Function HiWord(ByVal dw As Long) As Long
CopyMemory HiWord, ByVal VarPtr(dw) + 2, 2
End Function

Public Function MakeWord(ByVal LoWord As Long, HiWord As Long) As Long
Dim WordArr(0 To 1) As Long
WordArr(0) = LoWord
WordArr(1) = HiWord
CopyMemory MakeWord, ByVal VarPtr(WordArr(0)), 4
End Function

Public Function CreateLogFont(ByRef m_Font As StdFont, hDC As Long) As Long
   Dim lf As LogFont
   With lf
      .lfHeight = -(m_Font.Size * GetDeviceCaps(hDC, 90)) / 72
      .lfWidth = 0
      '.lfEscapement = m_Rotation * 10
      .lfOrientation = .lfEscapement
      .lfWeight = m_Font.Weight
      .lfItalic = m_Font.Italic
      .lfUnderline = m_Font.UnderLine
      .lfStrikeOut = m_Font.Strikethrough
      .lfClipPrecision = CLIP_DEFAULT_PRECIS
      .lfQuality = PROOF_QUALITY
      .lfPitchAndFamily = 0
      .lfFaceName = m_Font.Name & vbNullChar
      .lfCharSet = m_Font.Charset
      If .lfCharSet = OEM_CHARSET Then
         'If (m_Rotation Mod 360) <> 0 Then
         '   .lfCharSet = ANSI_CHARSET
         'End If
      End If
      'If (m_Rotation Mod 360) <> 0 Then
      '   .lfOutPrecision = OUT_TT_ONLY_PRECIS
      'Else
         .lfOutPrecision = OUT_DEFAULT_PRECIS
      'End If
   End With
   CreateLogFont = CreateFontIndirect(lf)
End Function

Public Function PtOutRect(r As RECT, p As POINTAPI) As Boolean
With r
    PtOutRect = p.X < .Left Or p.X > .Right Or p.Y < .Top Or p.Y > .Bottom
End With
End Function

Public Sub AddMRU(NewFile As String)
Dim i As Long, tFile As String
With gIni
    For i = 0 To 3
        tFile = .GetSetting("MRU", "File" & i)
        If tFile = "" Then Exit For
        If tFile = NewFile Then
            SetFirstMRU i
            Exit Sub
        End If
    Next i
    For i = 3 To 1 Step -1
        .SaveSetting "MRU", "File" & i, .GetSetting("MRU", "File" & i - 1)
    Next i
    .SaveSetting "MRU", "File0", NewFile
    LoadMRU
End With
End Sub

Public Sub LoadMRU()
Dim tFile As String, i As Long
With gIni
    For i = 0 To 3
        tFile = .GetSetting("MRU", "File" & i)
        If tFile = "" Then Exit For
        With frmMain.mnMru(i)
            .Caption = "&" & i + 1 & " " & tFile
            .Tag = tFile
            .Visible = True
        End With
    Next i
    If i Then frmMain.sepMru.Visible = True
End With
End Sub

Public Sub SetFirstMRU(MRU_Idx As Long)
Dim tFile As String, i As Long
With gIni
    tFile = .GetSetting("MRU", "File" & MRU_Idx)
    For i = MRU_Idx To 1 Step -1
        .SaveSetting "MRU", "File" & i, .GetSetting("MRU", "File" & i - 1)
    Next i
    .SaveSetting "MRU", "File0", tFile
End With
LoadMRU
End Sub

Public Function TranslateColor(ByVal clrColor As OLE_COLOR, Optional hPalette As Long = 0) As Long
If OleTranslateColor(clrColor, hPalette, TranslateColor) Then
  TranslateColor = &HFFFF
End If
End Function

Public Function IsLetterOrNumber(t As Long) As Boolean
    IsLetterOrNumber = ((t > 47 And t < 58) Or (t > 64 And t < 91) Or (t > 96 And t < 123))
End Function

Public Sub SleepWithEvents(mSeconds As Long)
Dim StartCount As Long, EndCount As Long
StartCount = GetTickCount
EndCount = StartCount + mSeconds
While GetTickCount < EndCount
    DoEvents
Wend
End Sub

'###########################################################################
'###########################################################################
'###########################################################################
Sub Main()
Dim ts As String, i As Long, t As Long
sepchar8 = Chr(8)
gIni.File = App.Path & "\ansieditor.ini"
'------------------
gColors(0) = 0&
gColors(1) = 128&
gColors(2) = 32768
gColors(3) = 32896
gColors(4) = 8388608
gColors(5) = 8388736
gColors(6) = 8421376
gColors(7) = 12632256
gColors(8) = 8421504
gColors(9) = 255&
gColors(10) = 65280
gColors(11) = 65535
gColors(12) = 16711680
gColors(13) = 16711935
gColors(14) = 16776960
gColors(15) = 16777215
gFontNames(0) = ""
gFontNames(1) = ""
gFontNames(2) = ""
gFontNames(3) = ""
For i = Screen.FontCount - 1 To 0 Step -1
    ts = Screen.Fonts(i)
    If InStr(ts, "") And Left(ts, 1) <> "@" Then
        gFontNames(3) = ts
        Exit For
    End If
Next i
For i = 1 To 13
    FontInfos(i).FontSize = i * 1.5
    FontInfos(i).BoxWidth = i * 80
    FontInfos(i).BoxHeight = i * 48
Next i
For i = 240 To 15 Step -15
   dwCustClrs((i \ 15) - 1) = RGB(i, i, i)
Next
Set gcCursors = New Collection
Dim tIco As StdPicture
With gcCursors
    Set tIco = LoadResPicture("curstamp", vbResCursor)
    .Add tIco, "stamp"
    Set tIco = LoadResPicture("currubber", vbResCursor)
    .Add tIco, "rubber"
    Set tIco = LoadResPicture("curflood", vbResCursor)
    .Add tIco, "flood"
    Set tIco = LoadResPicture("curcolorpicker", vbResCursor)
    .Add tIco, "colorpicker"
    Set tIco = LoadResPicture("curformatbrush", vbResCursor)
    .Add tIco, "formatbrush"
End With
gSelectAfterPaste = CLng(gIni.GetSetting("Options", "SelectAfterPaste", 0))
gIntelTrans = CLng(gIni.GetSetting("Options", "IntelTrans", 1))
gShowGrid = CLng(gIni.GetSetting("Options", "ShowGrid", 0))
gInterLine = CLng(gIni.GetSetting("Options", "InterLine", 0))
gGridColor = CLng(gIni.GetSetting("Options", "GridColor", "8421504"))
gGridStyle = CLng(gIni.GetSetting("Options", "GridStyle", "2"))
frmMain.Show
LoadMRU
InitIntelChars
'frmGroupArtChar.Show
End Sub

Public Sub ShellAndWait(ByVal strProg As String, ByVal lStyle As VbAppWinStyle)
   Dim ProcessId As Long
   Dim ProcessHandle As Long
   Const Access As Long = &H100000
   ProcessId = Shell(strProg, lStyle)
   Do
      ProcessHandle = OpenProcess(Access, False, ProcessId)
      If ProcessHandle <> 0 Then
         CloseHandle ProcessHandle
      End If
      DoEvents
      If gQuitting Then Exit Sub
   Loop Until ProcessHandle = 0
End Sub

Private Sub InitIntelChars()
'Dim i As Long, t As Long
gIntelCharRight0(0) = "TVX\^bdhjkmnp"
gIntelCharRight1(0) = "Tj[Y_apgemhkn"
gIntelCharRight0(1) = "li]cW©éĩЩԩթѩةܩ٩ݩ"
gIntelCharRight1(1) = "ilZ`fo-ȩʩ˩̩Щԩ֩ҩةܩکީs"
gIntelCharRight0(2) = "ũƩǩөש֩ҩ۩ߩکީ"
gIntelCharRight1(2) = "ɩͩΩϩөשթѩ۩ߩ٩ݩ"
gIntelCharRight0(3) = ""
gIntelCharRight1(3) = ""
gIntelCharRight0(4) = "xyz{|}"
gIntelCharRight1(4) = "xyz{|}~"
gIntelCharRight0(5) = ""
gIntelCharRight1(5) = ""
'---
gIntelCharLeft0(0) = "TY[_aeghjkmnp"
gIntelCharLeft1(0) = "Tj[Y_apgemhkn"
gIntelCharLeft0(1) = "Z`filȩʩ˩̩Щԩ֩ҩةܩکީ"
gIntelCharLeft1(1) = "W]cilo-©éĩЩԩթѩةܩ٩ݩt"
gIntelCharLeft0(2) = "ɩͩΩϩөשթѩ۩ߩ٩ݩ"
gIntelCharLeft1(2) = "ũƩǩөש֩ҩ۩ߩکީ"
gIntelCharLeft0(3) = ""
gIntelCharLeft1(3) = ""
gIntelCharLeft0(4) = "xyz{|}"
gIntelCharLeft1(4) = "xyz{|}~"
gIntelCharLeft0(5) = ""
gIntelCharLeft1(5) = ""
'---
gIntelCharUp0(0) = "U]^`acdfglmp"
gIntelCharUp1(0) = "UWXZ[cdfgijp"
gIntelCharUp0(1) = "bek_\néƩȩɩ˩Ωة۩٩ک"
gIntelCharUp1(1) = "VYbehn-©ũȩɩʩͩЩөѩҩqr"
gIntelCharUp0(2) = "©ĩũǩʩ̩ͩϩܩߩݩީ"
gIntelCharUp1(2) = "éĩƩǩ˩̩Ωϩԩשթ֩"
gIntelCharUp0(3) = ""
gIntelCharUp1(3) = ""
gIntelCharUp0(4) = ""
gIntelCharUp1(4) = ""
gIntelCharUp0(5) = ""
gIntelCharUp1(5) = ""
'---
gIntelCharBelow0(0) = "UWXZ[dcfgijp"
gIntelCharBelow1(0) = "U]^`adcfglmp"
gIntelCharBelow0(1) = "VYbehn©ũȩɩʩͩЩөѩҩ"
gIntelCharBelow1(1) = "\_bekn-éƩȩɩ˩Ωts"
gIntelCharBelow0(2) = "éĩƩǩ˩̩Ωϩԩשթ֩"
gIntelCharBelow1(2) = "©ĩũǩʩ̩ͩϩܩߩݩީ"
gIntelCharBelow0(3) = "xyz{|}~"
gIntelCharBelow1(3) = ""
gIntelCharBelow0(4) = ""
gIntelCharBelow1(4) = ""
gIntelCharBelow0(5) = ""
gIntelCharBelow1(5) = ""
End Sub

