VERSION 5.00
Begin VB.UserControl XBox 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   4785
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6750
   ClipBehavior    =   0  'None
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   ""
      Size            =   8.25
      Charset         =   134
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   FontTransparent =   0   'False
   ForeColor       =   &H00FFFFFF&
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   319
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   450
   ToolboxBitmap   =   "UserControl1.ctx":0000
   Begin VB.PictureBox MoveBox 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FF00FF&
      ForeColor       =   &H80000008&
      Height          =   870
      Left            =   3360
      MousePointer    =   5  'Size
      ScaleHeight     =   56
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   100
      TabIndex        =   0
      Top             =   2280
      Visible         =   0   'False
      Width           =   1530
   End
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   400
      Left            =   1935
      Top             =   3780
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   801
      Left            =   5925
      Top             =   3090
   End
End
Attribute VB_Name = "XBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private mSavedX As Long, mSavedY As Long

Private mCellWidth As Long, mCellHeight As Long, mTextSize As Long
Private bgHBrush As Long
Private mForeColor As Long
Private mBackColor As Long
Private mFontIndex As Long

Private BoxWidth As Long, BoxHeight As Long
Private Not_Shown As Boolean
Private mCaretRect As RECT
'Private mCaretShown As Boolean

Private mCell As CellType
Private stdCell As CellType

Public Event Resize()
Public Event Click(X As Long, Y As Long)
Public Event MouseMove(ByVal X As Long, ByVal Y As Long)
Public Event BlockMove(ByVal X As Long, ByVal Y As Long)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Long, Y As Long, dx As Single, dy As Single)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Long, Y As Long, dx As Single, dy As Single)
Public Event SelectedChanged(BoxSelected As Boolean)
Public Event HistoryChanged(HistoryState As HistoryState)
Public Event ColorPicked(ForeGround As Long, BackGround As Long, HighLight As Long)

Public Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)

Public Event BeginMoving()
Public Event EndMoving()

Private BoxRect As RECT

Private mBlinkDown As Boolean

Private SelStartX As Long, SelStartY As Long, SelEndX As Long, SelEndY As Long
Private mSelectedRect As RECT
Private mSelecting As Boolean
Private mSelected As Boolean
Private mMoving As Boolean
Private mShiftMode As Boolean
Private mColorChanged As Boolean

Public TransForeColor As Boolean
Public TransBackColor As Boolean
Private mMovePoint As POINTAPI
Private mMoveText As String
Private WithEvents mEditHis As EditHistory
Attribute mEditHis.VB_VarHelpID = -1
Private mShowGrid As Boolean
Private mLastStepCount As Long
Private mHtmlBlink As Boolean
Private mCaretCount As Long

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  ؼ -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Private Sub UserControl_Initialize()
Dim i As Long
bgHBrush = CreateSolidBrush(vbBlack)
Not_Shown = True
With stdCell
    .HighLight = 1
    .Reverse = False
    .ForeGround = 37
    .BackGround = 40
    .Blink = False
    .UnderLine = False
    .FontIndex = 0
End With
Set mEditHis = New EditHistory
Set mEditHis.Box = Me
mLastStepCount = 0
End Sub

Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub

Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

Private Sub UserControl_Show()
SetBkColor UserControl.hDC, vbBlack
SetTextColor UserControl.hDC, vbWhite
SetBkMode UserControl.hDC, 2
Not_Shown = False
UserControl_Resize
CopyMemory mCell, stdCell, 24
Clear
mBlinkDown = False
Timer1.Enabled = True
Timer2.Enabled = True
End Sub

Private Sub UserControl_Resize()
Static Resizing As Boolean
If Resizing Then Exit Sub
On Error Resume Next
If Not_Shown Then Exit Sub
Resizing = True
Dim i As Long, t As Single, t1 As Long, t2 As Long, bw As Long, bh As Long
For i = 13 To 1 Step -1
    bh = FontInfos(i).BoxHeight
    bw = FontInfos(i).BoxWidth
    If bh <= UserControl.ScaleHeight And (bw <= UserControl.ScaleWidth) Then
        t = FontInfos(i).FontSize
        If UserControl.FontSize <> t Then
            Timer1.Tag = Timer1.Enabled
            UserControl.FontSize = t
            BoxWidth = UserControl.ScaleWidth ' bw
            BoxHeight = UserControl.ScaleHeight ' bh
            BoxRect.Right = BoxWidth
            BoxRect.Bottom = BoxHeight
            SetGDIFonts
            ReRenderScreen
            mBlinkDown = False
            Timer1.Enabled = Timer1.Tag
        End If
        Exit For
    End If
Next i
SetCaretPosition mCellWidth * mX, mCellHeight * (mY + 1)
'If mCaretShown Then Timer2_Timer
'Timer2.Enabled = True
RaiseEvent Resize
Resizing = False
End Sub

Private Sub UserControl_Terminate()
On Error Resume Next
DeleteObject bgHBrush
Set mEditHis = Nothing
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
Dim tx As Long, ty As Long
tx = X \ mCellWidth
ty = Y \ mCellHeight
If Button = 1 Then
    If gCurTool <> NoTool Then
        mEditHis.AddStep
        Exit Sub
    End If
    SelStartX = tx
    SelStartY = ty
    If IsHalfChar(tx, ty) Then SelStartX = SelStartX - 1
    SelEndX = SelStartX
    SelEndY = SelStartY
    If mMoving Then
        '
        EndMove
        Exit Sub
    End If
    If mSelected Then
        With mSelectedRect
        If SelStartX < .Left Or SelStartX > .Right Or SelStartY < .Top Or SelStartY > .Bottom Then '׼ƶ
            CancelSelected
        Else
            RaiseEvent BeginMoving
            BeginMove
        End If
        End With
    Else
        '
    End If
'Else    'right button
End If
RaiseEvent MouseDown(Button, Shift, tx, ty, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
Dim tx As Long, ty As Long
Dim ts As String, i As Long, t As Long, t1 As Long, t2 As Long, b As Byte, bt() As Byte
tx = X \ mCellWidth
ty = Y \ mCellHeight
If mMoving Then
    Exit Sub
End If
RaiseEvent MouseMove(tx, ty)
If Button = 1 Then
    Select Case gCurTool
        Case NoTool
        Case StampTool
            'zz
            If tx > -1 And ty > -1 And tx < 81 And ty < 25 Then
                ts = frmMain.txtStamp & " "
                ts = StrConv(Left(ts, 1), vbFromUnicode)
                bt = ts
                t = LenB(ts)
                If t > 1 Then
                    If tx > 0 Then
                        If (bt(0) = mChars(tx - 1, ty) And bt(1) = mChars(tx, ty)) Or (bt(0) = mChars(tx + 1, ty) And bt(1) = mChars(tx + 2, ty)) Then Exit Sub
                    End If
                End If
                '---/
                mEditHis.CurStep.AddCells tx, ty, tx + t - 1, ty
                '---/
                CopyMemory mChars(tx, ty), bt(0), t
                CopyMemory mCells(tx, ty), mCell, 24&
                If t = 2 Then CopyMemory mCells(tx + 1, ty), mCell, 24&
                ReRenderRegion 0, ty, 80, ty
            End If
            Exit Sub
        Case RubberTool
            'zz
            If tx > -1 And ty > -1 And tx < 81 And ty < 25 Then
                If IsHalfChar(tx + 1, ty) Then
                    '---/
                    mEditHis.CurStep.AddCell tx + 1, ty
                    '---/
                    mChars(tx + 1, ty) = 32
                    CopyMemory mCells(tx + 1, ty), stdCell, 24&
                Else
                    If IsHalfChar(tx, ty) Then
                        '---/
                        mEditHis.CurStep.AddCell tx - 1, ty
                        '---/
                        mChars(tx - 1, ty) = 32
                        CopyMemory mCells(tx - 1, ty), stdCell, 24&
                    End If
                End If
                '---/
                mEditHis.CurStep.AddCell tx, ty
                '---/
                mChars(tx, ty) = 32
                CopyMemory mCells(tx, ty), stdCell, 24&
                ReRenderRegion 0, ty, 80, ty
            End If
            Exit Sub
        Case FormatBrushTool
            If tx > -1 And ty > -1 And tx < 81 And ty < 25 Then
                If IsHalfChar(tx + 1, ty) Then
                    '---/
                    mEditHis.CurStep.AddCell tx + 1, ty
                    '---/
                    CopyMemory mCells(tx + 1, ty), mCell, 24&
                    'frmMain.Caption = Now
                Else
                    If IsHalfChar(tx, ty) Then
                        '---/
                        mEditHis.CurStep.AddCell tx - 1, ty
                        '---/
                        CopyMemory mCells(tx - 1, ty), mCell, 24&
                    End If
                End If
                '---/
                mEditHis.CurStep.AddCell tx, ty
                '---/
                CopyMemory mCells(tx, ty), mCell, 24&
                ReRenderRegion 0, ty, 80, ty
            End If
            Exit Sub
        Case Else
            Exit Sub
            'zz
    End Select
jmp:

    If tx < 0 Then
        tx = 0
    ElseIf tx > 80 Then
        tx = 80
    End If
    If ty < 0 Then
        ty = 0
    ElseIf ty > 23 Then
        ty = 23
    End If
    If tx <> SelEndX Or ty <> SelEndY Then
        If tx > 0 Then
                SelEndX = tx
                SelEndY = ty
            If SelStartX > tx Then
                t1 = tx
                t2 = SelStartX
            Else
                t1 = SelStartX
                t2 = tx
            End If
            If IsHalfChar(tx, ty) Then GoTo NoSelect
        End If
        If SelStartX = SelEndX Then
            CancelSelecting
            'Timer2.Enabled = True
            'ReRenderScreen@
            ReRenderSelected
        Else
            mSelecting = True
            'Timer2.Enabled = False
            'If mCaretShown Then InvertRect UserControl.hDC, mCaretRect
            'mCaretShown = False
            SelectRegion SelStartX, SelStartY, SelEndX, SelEndY, (Shift And vbShiftMask) > 0
        End If
NoSelect:
    End If
End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Dim tTimer2Enabled As Boolean
'tTimer2Enabled = Timer2.Enabled
'If tTimer2Enabled Then HideCaret
On Error Resume Next
If mMoving Then
    '
    GoTo jmp
End If
Dim tx As Long, ty As Long
tx = X \ mCellWidth
ty = Y \ mCellHeight
If Button = 1 Then
    If gCurTool <> NoTool Then
        If mEditHis.CurStep.IsEmpty Then mEditHis.CancelAddStep 'Else ReRenderScreen@
    End If
    Select Case gCurTool
        Case NoTool
        Case FloodTool
            If tx > -1 And ty > -1 And tx < 81 And ty < 25 Then mEditHis.AddStep: FloodFill tx, ty: ReRenderScreen
            Exit Sub
        Case ColorPickerTool
            If tx > -1 And ty > -1 And tx < 81 And ty < 25 Then
                With mCells(tx, ty)
                    RaiseEvent ColorPicked(.ForeGround, .BackGround, .HighLight)
                End With
            End If
            GoTo jmp
        Case Else
            GoTo jmp
    End Select
    If mSelecting Then
        CancelSelecting
        mSelected = True
        'ReRenderScreen@
        ReRenderSelected
        RaiseEvent SelectedChanged(True)
    Else
        If tx < 80 And ty < 24 Then RaiseEvent Click(tx, ty)
    End If
'Else
    'If gCurTool = NoTool Then RaiseEvent WantPopupMenu(x + 2, y + 2)
End If
RaiseEvent MouseUp(Button, Shift, tx, ty, X, Y)
jmp:
'If tTimer2Enabled Then ShowCaret
End Sub

Private Sub UserControl_Paint()
ReRenderScreen
End Sub

Public Property Get hWnd() As Long
hWnd = UserControl.hWnd
End Property

Public Sub KillMe()
Timer1.Enabled = False
End Sub

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=     ѡ    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Public Sub CancelSelecting()
ZeroMemory mSelectedCells(0, 0), 82 * 26 * 2&
mSelecting = False
mSelected = False
'InvertRect UserControl.hDC, mCaretRect
'Timer2.Enabled = True
End Sub

Public Sub CancelSelected()
If mSelected Then
    mSelected = False
    With mSelectedRect
        ReRenderRegion 0, .Top, 81, .Bottom
    End With
'    ShowCaret
    RaiseEvent SelectedChanged(False)
End If
'InvertRect UserControl.hDC, mCaretRect
'mCaretShown = True
'mCaretShown = False
'Timer2.Enabled = True
End Sub

Public Property Get Selecting() As Boolean
Selecting = mSelecting
End Property

Public Property Get Selected() As Boolean
Selected = mSelected
End Property

Public Sub SelectRegion(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, Optional ShiftDown As Boolean = False)
Dim i  As Long, j As Long, t As Long, ts As String, t1 As Long
Dim b As Boolean, b1 As Boolean, bts(81) As Byte, tx As Long, ct1 As Long, tForeColor As Long
Dim m As Boolean, m1 As Boolean, ShowBlink As Boolean, LineMode As Boolean
Dim u As Boolean, u1 As Boolean, ut As Long, ui As Long
Dim tX1 As Long, tx2 As Long, ty1 As Long, ty2 As Long
If X1 > X2 Then
    t = X1
    X1 = X2
    X2 = t
End If
If Y1 > Y2 Then
    t = Y1
    Y1 = Y2
    Y2 = t
End If
ZeroMemory mSelectedCells(0, 0), 82 * 26 * 2&
With mSelectedRect
    If X1 < .Left Then tX1 = X1 Else tX1 = .Left
    .Left = X1
    If X2 > .Right Then tx2 = X2 Else tx2 = .Right + 1
    .Right = X2 - 1
    If Y1 < .Top Then ty1 = Y1 Else ty1 = .Top
    .Top = Y1
    If Y2 > .Bottom Then ty2 = Y2 Else ty2 = .Bottom
    .Bottom = Y2
    'SetText hStatBar, 1, SBT_SUNKEN, ""
End With

For i = Y1 To Y2
    For j = X1 To X2 - 1
        mSelectedCells(j, i) = True
    Next j
Next i
'HideCaret
ReRenderRegion 0, ty1, 80, ty2
End Sub

Private Sub MoveBox_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Debug.Print X & "," & Y & "    '" & Now
If Button = 1 Then
    Dim tx As Long, ty As Long
    tx = (MoveBox.Left + X - mMovePoint.X) / mCellWidth
    ty = (MoveBox.Top + Y - mMovePoint.Y) / mCellHeight
    RaiseEvent BlockMove(tx, ty)
    MoveBox.Move tx * mCellWidth - 1, ty * mCellHeight - 1
End If
End Sub

Private Sub MoveBox_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
mMovePoint.X = X
mMovePoint.Y = Y
End Sub

Public Property Get Moving() As Boolean
Moving = mMoving
End Property

Private Sub BeginMove()
Dim t As Long, tX1 As Long, ty1 As Long, cx As Long, cy As Long
'If mCaretShown Then InvertRect UserControl.hDC, mCaretRect
'Timer2.Enabled = False
'mCaretShown = False
mMoving = True
With mSelectedRect
    'movebox.paintpicture
    tX1 = .Left * mCellWidth
    ty1 = .Top * mCellHeight
    cx = (.Right - .Left + 1) * mCellWidth + 2
    cy = (.Bottom - .Top + 1) * mCellHeight + 2
    MoveBox.AutoRedraw = True
    MoveBox.Move tX1 - 1, ty1 - 1, cx, cy
    BitBlt MoveBox.hDC, 0, 0, cx, cy, UserControl.hDC, tX1, ty1, vbSrcCopy
    MoveBox.AutoRedraw = False
    Debug.Print "begin move!!!!!!!!!!" & Now
    mMoveText = CopyText
    Delete , True
    MoveBox.Visible = True
    Dim r As RECT, r1 As RECT, p As POINTAPI
    GetCursorPos p
    GetWindowRect MoveBox.hWnd, r
    mMovePoint.X = p.X - r.Left
    mMovePoint.Y = p.Y - r.Top
    Screen.MousePointer = 5
    SetCapture MoveBox.hWnd
    Screen.MousePointer = 0
End With
RaiseEvent SelectedChanged(False)
End Sub

Public Sub EndMove(Optional PasteDown As Boolean = True)
Dim tx As Long, ty As Long
tx = MoveBox.Left / mCellWidth  ' = (MoveBox.Left + x - mMovePoint.x) + 1
ty = MoveBox.Top / mCellHeight
mMoving = False
mSelected = False
ReleaseCapture
If PasteDown Then PasteEscText mMoveText, tx, ty, False
MoveBox.Visible = False
If tx = mSelectedRect.Left And ty = mSelectedRect.Top Then
    mEditHis.CancelAddStep
End If
'ShowCaret
'Timer2_Timer
'Timer2.Enabled = True
RaiseEvent EndMoving
End Sub

Public Sub SetSelected(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long)
If X1 = X2 And Y1 = Y2 Then Exit Sub
mSelected = True
'HideCaret
With mSelectedRect
    .Left = X1
    .Right = X2 - 1
    .Top = Y1
    .Bottom = Y2
    ReRenderRegion .Left, .Top, .Right + 1, .Bottom
End With
RaiseEvent SelectedChanged(True)
End Sub

Public Property Get SelectedText() As String
With mSelectedRect
    SelectedText = GetEscText(.Left, .Top, .Right, .Bottom)
End With
End Property

Public Property Get SelectedWidth() As Long
SelectedWidth = mSelectedRect.Right - mSelectedRect.Left + 1
End Property

Public Property Get SelectedHeight() As Long
SelectedHeight = mSelectedRect.Bottom - mSelectedRect.Top + 1
End Property

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=     洦    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Private Sub SetGDIFonts()
Dim tLF As Long
tLF = CreateLogFont(UserControl.Font, UserControl.hDC)
mCellWidth = UserControl.TextWidth("") / 2
mCellHeight = UserControl.TextHeight("")
End Sub

Public Property Let Enabled(NewEnabled As Boolean)
UserControl.Enabled = NewEnabled
End Property
Public Property Get Enabled() As Boolean
Enabled = UserControl.Enabled
End Property

Public Property Let ShowGrid(ByVal NewShowGrid As Boolean)
mShowGrid = NewShowGrid
If NewShowGrid Then DrawGrid Else ReRenderScreen
End Property

Public Property Get ShowGrid() As Boolean
ShowGrid = mShowGrid
End Property

Public Sub DrawGrid(Optional ByVal X1 As Long = 0, Optional ByVal Y1 As Long = 0, Optional ByVal X2 As Long = 80, Optional ByVal Y2 As Long = 23)
Dim X As Long, Y As Long, t As Long, tdc As Long, t1 As Long, tColor As Long
UserControl.DrawStyle = gGridStyle
tColor = UserControl.ForeColor
UserControl.ForeColor = gGridColor
tdc = UserControl.hDC
t1 = 24 * mCellHeight
For X = X1 To X2
    t = X * mCellWidth
    MoveTo tdc, t, 0, 0
    LineTo tdc, t, t1
Next X
UserControl.ForeColor = gGridColor
t1 = 80 * mCellWidth
Y2 = Y2 + 1
For Y = Y1 To Y2
    t = Y * mCellHeight
    MoveTo tdc, 0, t, 0
    LineTo tdc, t1, t
Next Y
UserControl.DrawStyle = 0
UserControl.ForeColor = tColor
End Sub


'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=     ı    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Public Sub Clear()
'Dim tTimer2Enabled As Boolean
'tTimer2Enabled = Timer2.Enabled
'If tTimer2Enabled Then HideCaret
'---/
mEditHis.AddStep
mEditHis.CurStep.AddCells 0, 0, 80, 24
'---/
FillRect UserControl.hDC, BoxRect, bgHBrush
'ZeroMemory mCells(0, 0), 82 * 26 * 24&
ResetCells 0, 0, 81, 25
FillMemory mChars(0, 0), 256 * 26&, 32
CopyMemory mCell, stdCell, 24
FontIndex = 0
mColorChanged = True
mX = 0
mY = 0
mCaretCount = 0
'mCaretShown = False
'If tTimer2Enabled Then ShowCaret
End Sub

Public Sub Clear1()
If mX < 0 Then mX = 0
If mX > 80 Then mX = 80
If mY < 0 Then mY = 0
If mY > 23 Then mY = 23
Dim r As RECT
With r
    .Left = mCellWidth * mX
    .Top = mCellHeight * mY
    .Bottom = .Top + mCellHeight
    .Right = BoxWidth
End With
FillRect UserControl.hDC, r, bgHBrush
With r
    .Left = 0
    .Top = mCellHeight * (mY + 1)
    .Bottom = BoxHeight
End With
FillRect UserControl.hDC, r, bgHBrush
FillMemory mChars(mX, mY), 256 * (26 - mY) - mX, 32
'ZeroMemory mCells(mX, mY), (82 * (26 - mY) - mX) * 24&
ResetCells mX, mY, 81 - mX, 25 - mY
Dim tBlink As Boolean
tBlink = mCell.Blink
CopyMemory mCell, stdCell, 24
mCell.Blink = tBlink
FontIndex = 0
mColorChanged = True
mX = 0
mY = 0
mCaretCount = 0
'mCaretShown = False
End Sub

Public Sub ClrEoL()
Dim r As RECT
With r
    .Left = mCellWidth * mX
    .Top = mCellHeight * mY
    .Bottom = .Top + mCellHeight
    .Right = BoxWidth
End With
If mX > 79 Then Exit Sub
'HideCaret
mEditHis.AddStep
mEditHis.CurStep.AddCells mX, mY, 80, mY
FillRect UserControl.hDC, r, bgHBrush
ResetCells mX, mY, 81 - mX, mY
FillMemory mChars(mX, mY), 256 - mX, 32
'ShowCaret
End Sub

Public Property Let PauseBlink(NewPauseBlink As Boolean)
mBlinkDown = False
Timer1.Enabled = Not NewPauseBlink
End Property

Private Sub Timer1_Timer()
mBlinkDown = Not mBlinkDown
ShowBlinkText
End Sub

Public Function GetHtmlText(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long) As String
Dim i  As Long, j As Long, t As Long, ts As String, t1 As Long
Dim bts(81) As Byte, tx As Long, ct1 As Long, tForeColor As Long
Dim ShowBlink As Boolean
Dim b As Boolean, b1 As Boolean, r As Boolean, r1 As Boolean, h As Long, h1 As Long
Dim bTmp As Boolean
Dim f As Long, f1 As Long, bk As Long, bk1 As Long, u As Boolean, u1 As Boolean, fi As Long, fi1 As Long
Dim allTs As String
If gHtmlColors(0) = "" Then
    gHtmlColors(0) = "#000000"
    gHtmlColors(1) = "#800000"
    gHtmlColors(2) = "#008000"
    gHtmlColors(3) = "#808000"
    gHtmlColors(4) = "#000080"
    gHtmlColors(5) = "#800080"
    gHtmlColors(6) = "#008080"
    gHtmlColors(7) = "#c0c0c0"
    gHtmlColors(8) = "#808080"
    gHtmlColors(9) = "#ff0000"
    gHtmlColors(10) = "#00ff00"
    gHtmlColors(11) = "#ffff00"
    gHtmlColors(12) = "#0000ff"
    gHtmlColors(13) = "#ff00ff"
    gHtmlColors(14) = "#00ffff"
    gHtmlColors(15) = "#FFFFFF"
End If
allTs = LoadCellAttributesForHtml(X1, Y1)
With mCells(X1, Y1)
    b = .Blink
    r = .Reverse
    h = .HighLight
    f = .ForeGround
    bk = .BackGround
    u = .UnderLine
    fi = .FontIndex
End With
For i = Y1 To Y2
    t = X1
    For j = X1 To X2
        With mCells(j, i)
            b1 = .Blink
            r1 = .Reverse
            h1 = .HighLight
            f1 = .ForeGround
            bk1 = .BackGround
            u1 = .UnderLine
            fi1 = .FontIndex
        End With
        If b1 <> b Or r1 <> r Or h1 <> h Or f1 <> f Or bk1 <> bk Or u1 <> u Or fi <> fi1 Then
            'MsgBox bk
            b = b1
            r = r1
            h = h1
            f = f1
            bk = bk1
            u = u1
            fi = fi1
            ts = StrConv(MidB(bts, t + 1, j - t), vbUnicode)
            If ts <> " " Then allTs = allTs & LoadCellAttributesForHtml(t, i)
            allTs = allTs & Replace(Replace(ts, " ", "&nbsp;"), "<", "&lt;")
            t = j
        End If
        bts(j) = mChars(j, i)
        If bts(j) = 0 Then bts(j) = 32
    Next j
    ts = RTrim(StrConv(MidB(bts, t + 1, X2 - t), vbUnicode))
    If ts <> "" Then allTs = allTs & LoadCellAttributesForHtml(t, i) & Replace(Replace(ts, " ", "&nbsp;"), "<", "&lt;")
    If t <> X1 Then allTs = allTs & "</span>"
    allTs = allTs & "<br>" & vbCrLf
Next i
GetHtmlText = allTs & "<!--ae2-->"
End Function

Public Sub PasteEscText(EscText As String, Optional ByVal tx As Long = -999, Optional ByVal ty As Long = -999, Optional AddStep As Boolean = True, Optional tx2 As Long, Optional ty2 As Long, Optional PasteType As ePasteTypeEnum = pt_PasteAll)
Dim c As Byte, d As Byte, s As String, dat As String, v As Long, LL
Dim i As Long, j As Long, t As Long, t1 As Long, ts As String, tarr As Variant
Dim b As Byte, xx As Long, yy As Long
Dim EscStartIdx As Long, BlankEscStr As Boolean, AbandonCount As Long, ResetAttr As Boolean
'---
Dim parseBack As Boolean, parseFore As Boolean
Select Case PasteType
    Case pt_PasteAll
        parseBack = True
        parseFore = True
    Case pt_PasteNoBackAndForeGround
    Case pt_PasteNoBackGround
        parseFore = True
    Case pt_PasteNoForeGround
        parseBack = True
End Select
'---
Dim bts() As Byte, btsUbound As Long, mi As Long, tCell As CellType, curX As Long, curY As Long, MaxX As Long
'Dim EscText As String, tx As Long, ty As Long   'zzz
'EscText = Clipboard.GetText
'msgbox
On Error Resume Next
If tx = -999 Then tx = mX
If ty = -999 Then ty = mY
curX = tx
curY = ty
bts = StrConv(Replace(EscText, Chr(27) & Chr(27), Chr(27)), vbFromUnicode)
btsUbound = UBound(bts)
If btsUbound < 0 Then Exit Sub
'---/
If AddStep Then mEditHis.AddStep
'---/
CopyMemory tCell, mCells(tx, ty), 24&
With tCell
    If parseFore Then
        .Blink = False
        .FontIndex = 0
        .ForeGround = 37
        .HighLight = 1
        .Reverse = False
        .UnderLine = False
    End If
    If parseBack Then
        .BackGround = 40
    End If
End With
For mi = 0 To btsUbound
    Select Case bts(mi)
    Case 27
        mi = mi + 1
        c = bts(mi)
        If c <> 91 Then
            If mi <= btsUbound And c = 27 Then
                mi = mi + 1
            Else
                b = c
                Do
                    If (b > 96 And b < 123) Or (b > 64 And b < 91) Then GoTo EndParseEsc
                    mi = mi + 1
                    b = bts(mi)
                Loop
            End If
        End If
        EscStartIdx = mi + 1
        AbandonCount = 0
        ResetAttr = False
        Do
            mi = mi + 1
            b = bts(mi)
            If b < 48 Or b > 59 Then  '0-9,":",";"
                If mi = EscStartIdx Then
                    BlankEscStr = True
                Else
                    tarr = Split(StrConv(MidB(bts, EscStartIdx + 1, mi - EscStartIdx), vbUnicode), ";")
                    t = UBound(tarr)
                    BlankEscStr = False
                End If
                Select Case b
                    Case 109    'm
                        If BlankEscStr Or ResetAttr Then
                            'CopyMemory tCell, stdCell, 24&
                            With tCell
                                If parseFore Then
                                    .Blink = False
                                    .FontIndex = 0
                                    .ForeGround = 37
                                    .HighLight = 1
                                    .Reverse = False
                                    .UnderLine = False
                                End If
                                If parseBack Then .BackGround = 40
                            End With
                        Else
                            For j = 0 To t
                                If tarr(j) <> "" Then
                                    t1 = Val(tarr(j))
                                    If t1 > 29 And t1 < 38 Then
                                        If parseFore Then tCell.ForeGround = t1
                                    ElseIf t1 > 39 And t1 < 48 Then
                                        If parseBack Then tCell.BackGround = t1
                                    ElseIf t1 = 0 Then
                                        With tCell
                                            If parseFore Then
                                                .Blink = False
                                                .FontIndex = 0
                                                .ForeGround = 37
                                                .HighLight = 0
                                                .Reverse = False
                                                .UnderLine = False
                                            End If
                                            If parseBack Then .BackGround = 40
                                        End With
                                    ElseIf t1 = 1 Then
                                        If parseFore Then tCell.HighLight = 1
                                    ElseIf t1 = 5 Then
                                        If parseFore Then tCell.Blink = True
                                    ElseIf t1 = 7 Then
                                        If parseFore Then tCell.Reverse = True
                                    ElseIf t1 = 4 Then
                                        If parseFore Then tCell.UnderLine = True
                                    End If
                                End If
                            Next j
                        End If
                    Case 73 'I
                        If BlankEscStr Then
                            t = 0
                        Else
                            t = Val(tarr(0))
                            If t < 1 Then t = 0
                        End If
                        If parseFore Then tCell.FontIndex = t
                    Case Else
                        If (b > 96 And b < 123) Or (b > 64 And b < 91) Then
                            GoTo EndParseEsc
                        Else
                            If b = 10 Then ResetAttr = True
                            AbandonCount = AbandonCount + 1
                            If AbandonCount > 12 Then
                                mi = EscStartIdx
                                GoTo L2
                            Else
                                GoTo jmpLoopOn
                            End If
                        End If
                End Select
                Exit Do
            End If
jmpLoopOn:
        Loop
EndParseEsc:
    Case 13
    Case 10
        curX = tx
        curY = curY + 1
    Case 0
    Case 10
    Case Else
        '---/
        mEditHis.CurStep.AddCell curX, curY
        If Not parseBack Then tCell.BackGround = mCells(curX, curY).BackGround
        If parseFore Then
            CopyMemory mCells(curX, curY), tCell, 24&
        Else
            mCells(curX, curY).BackGround = tCell.BackGround
        End If
        mChars(curX, curY) = bts(mi)
        curX = curX + 1
        If curX > MaxX Then MaxX = curX
    End Select
L2:
    If curY > 23 Then Exit For
Next mi
mX = curX
mY = curY
If IsHalfChar(mX - 1, mY) Then
    ReDim bts(1)
    bts(0) = mChars(mX - 2, mY)
    bts(1) = mChars(mX - 1, mY)
    gLastChar = StrConv(bts, vbUnicode)
Else
    gLastChar = Chr(mChars(mX - 1, mY))
End If
'SetCaretPosition mCellWidth * , mCellHeight * (curY + 1)
'Dim tTimer2Enabled As Boolean
'tTimer2Enabled = Timer2.Enabled
'If tTimer2Enabled Then HideCaret
ReRenderScreen
'If tTimer2Enabled Then ShowCaret
tx2 = MaxX
ty2 = curY
If tx2 > 80 Then tx2 = 80
If ty2 > 23 Then ty2 = 23
End Sub

Public Function GetPlainText(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long) As String
Dim Y As Long, t As Long, ts As String, bt() As Byte, LineLen As Long
ReDim bt(X2 - X1)
LineLen = X2 - X1 + 1
For Y = Y1 To Y2
    CopyMemory bt(0), mChars(X1, Y), LineLen
    ts = ts & StrConv(bt, vbUnicode) & vbCrLf
Next Y
GetPlainText = Left(ts, Len(ts) - 2)
End Function

Public Function GetEscText(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long) As String
'************************************************************
'********          Edited by flubber @smth           ********
'********                 2002.08.19                 ********
'********                                            ********
'******** 1. some bugs of underline and blink fixed  ********
'******** 2. a more robust file head with 0m or 1m   ********
'******** 3. some excessive codes cleared            ********
'************************************************************

On Error Resume Next
Dim i  As Long, j As Long, t As Long, ts As String, t1 As Long
Dim bts(81) As Byte, tx As Long, ct1 As Long, tForeColor As Long
Dim ShowBlink As Boolean
Dim b As Boolean, b1 As Boolean, r As Boolean, r1 As Boolean, h As Long, h1 As Long, fi As Long, fi1 As Long, u As Long, u1 As Long
Dim bSecondPosition As Boolean
Dim f As Long, f1 As Long, bk As Long, bk1 As Long
Dim EscStr As String, EscHead As String
Dim Need0 As Boolean
EscHead = Chr(27) & Chr(27) & "["
b = False
r = False
h = 0
f = 0
bk = 0
fi = 0
u = 0
For i = Y1 To Y2
    t = X1
    For j = X1 To X2
        If mCells(j, i).ForeGround = 0 Then
            b1 = False
            r1 = False
            h1 = 1
            f1 = 37
            bk1 = 40
            fi1 = 0
            u1 = 0
        Else
            With mCells(j, i)
                b1 = .Blink
                r1 = .Reverse
                h1 = .HighLight
                f1 = .ForeGround
                bk1 = .BackGround
                fi1 = .FontIndex
                u1 = .UnderLine
            End With
        End If
        If Not bSecondPosition Then
            ts = ""
            Need0 = False
            If i = Y1 And j = X1 Or j = 80 Then Need0 = True
            If r1 > r Or u1 > u Or (b1 > b Or h1 < h) And mChars(j, i) <> 0 And mChars(j, i) <> 32 Then Need0 = True
            If Need0 Then
                ts = ";0" & ts
                b = False
                r = False
                h = 0
                f = 37
                bk = 40
                fi = 0
                u = 0
            End If
            If h1 <> h And mChars(j, i) <> 0 And mChars(j, i) <> 32 Then
                ts = ts & ";1"
                h = h1
            End If
            If u1 <> u Then
                ts = ts & ";4"
                u = u1
            End If
            If b1 <> b And mChars(j, i) <> 0 And mChars(j, i) <> 32 Then
                ts = ts & ";5"
                b = b1
            End If
            If r1 <> r Then
                ts = ts & ";7"
                r = r1
            End If
            If f1 <> f And mChars(j, i) <> 0 And mChars(j, i) <> 32 Then
                ts = ts & ";" & f1
                f = f1
            End If
            If bk1 <> bk And (b1 Or r1 Or mChars(j, i) <> 168 Or mChars(j + 1, i) <> 128) Then
                ts = ts & ";" & bk1
                bk = bk1
            End If
            If Len(ts) Then
                ts = EscHead & Mid(ts, 2) & "m"
                EscStr = EscStr & StrConv(ts, vbFromUnicode)
            End If
            If fi1 <> fi Then
                ts = EscHead & IIf(fi1, fi1, "") & "I"
                EscStr = EscStr & StrConv(ts, vbFromUnicode)
                fi = fi1
            End If
        End If
        bts(j) = mChars(j, i)
        If bts(j) = 0 Then bts(j) = 32
        EscStr = EscStr & ChrB(bts(j))
        
        If bSecondPosition Then
            bSecondPosition = False
        Else
            bSecondPosition = bts(j) >= 128
        End If
    Next j
    If i < Y2 Then
        If Not gInterLine Then
            EscStr = EscStr & StrConv(EscHead & "0m", vbFromUnicode)
            b = False
            r = False
            h = 0
            f = 37
            bk = 40
            fi = 0
            u = 0
        End If
        EscStr = EscStr & ChrB(13) & ChrB(10)
    End If
Next i
GetEscText = StrConv(EscStr & StrConv(EscHead & "m", vbFromUnicode), vbUnicode)
End Function

Public Sub BackSpace()
Dim t As Long, tX1 As Long, tx2 As Long, bt(1) As Byte
If mMoving Then
    EndMove False
    Exit Sub
End If
Dim r As RECT
If mX = 0 Then  '
    mX = 80
    mY = mY - 1
    If mY < 0 Then
        mX = 0
        mY = 0
    Else
        BackSpace
    End If
    Exit Sub
End If
tX1 = mX - 1: tx2 = tX1
'bt(0) = mChars(tx1, mY)
'bt(1) = mChars(tx1 + 1, mY)
If IsHalfChar(tx2, mY) Then
    tX1 = tX1 - 1
    't = 2
    t = 1
Else
    't = 1
    t = 0
End If
If gInsertMode Then '//zzz
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells tX1, mY, 81, mY
    '---/
    tx2 = tX1 + t + 1
    MoveMemory mCells(tX1, mY), mCells(tx2, mY), (81 - tx2 + 1) * 24&
    MoveMemory mChars(tX1, mY), mChars(tx2, mY), 255 - tx2 + 1
    ResetCells 81 - t - 1, mY, 81, mY
    FillMemory mChars(81 - t - 1, mY), t + 1, 32&
    mX = tX1
    ReRenderRegion tX1, mY, 80, mY
Else
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells tX1, mY, tx2, mY
'    HideCaret
    '---/
    With r
        .Left = mCellWidth * tX1
        .Top = mCellHeight * mY
        .Bottom = .Top + mCellHeight
        .Right = mCellWidth * (tx2 + 1)
    End With
    FillRect UserControl.hDC, r, bgHBrush
    ResetCells tX1, mY, tX1 + t, mY
    FillMemory mChars(tX1, mY), t + 1, 32
    mX = tX1
    SetCaretPosition mCellWidth * mX, mCellHeight * (mY + 1)
'    ShowCaret
End If
End Sub


Public Sub Copy(Optional CopyType As eCopyTypeEnum = ct_EscText)
If mMoving Then
    Clipboard.Clear
    Clipboard.SetText mMoveText
    Exit Sub
End If
Clipboard.Clear
Clipboard.SetText CopyText(CopyType)
CancelSelected
End Sub

Public Sub Delete(Optional AddStep As Boolean = True, Optional ForceDelete As Boolean = False)
If ForceDelete Then GoTo jmp
If mMoving Then
    EndMove False
    Exit Sub
End If
If mSelected Then
jmp:
    Dim X As Long, Y As Long, X1 As Long, X2 As Long
    With mSelectedRect
        If AddStep Then mEditHis.AddStep
        For Y = .Top To .Bottom
            X1 = .Left
            X2 = .Right
            If IsHalfChar(.Left, Y) Then X1 = X1 - 1
            If IsHalfChar(.Right + 1, Y) Then X2 = X2 + 1
            mEditHis.CurStep.AddCells X1, Y, X2, Y
            For X = X1 To X2
                CopyMemory mCells(X, Y), stdCell, 24&
                mChars(X, Y) = 32
            Next X
        Next Y
    End With
    mSelected = False
    'ReRenderScreen@
    ReRenderSelected
Else
    MoveRight 1
    BackSpace
End If
End Sub

Public Sub Cut()
If mMoving Then
    Clipboard.Clear
    Clipboard.SetText mMoveText
    EndMove False
    Exit Sub
End If
Clipboard.Clear
Clipboard.SetText CopyText
Delete
End Sub

Public Sub Paste(Optional PasteType As ePasteTypeEnum = pt_PasteAll)
If mSelected Then
    CancelSelected
'    ShowCaret
ElseIf mMoving Then
    Exit Sub
End If
Dim ts As String
ts = Clipboard.GetText
If ts <> "" Then
    Dim tX1 As Long, ty1 As Long, tx2 As Long, ty2 As Long
    tX1 = mX
    ty1 = mY
    If InStr(1, ts, "<!--ae2-->") Then
        PasteHtmlText ts, mX, mY, True, tx2, ty2, PasteType
    Else
        PasteEscText ts, mX, mY, True, tx2, ty2, PasteType
    End If
    If gSelectAfterPaste Then SetSelected tX1, ty1, tx2, ty2
End If
End Sub

Public Function CopyText(Optional CopyType As eCopyTypeEnum = ct_EscText) As String
Dim ts As String
If mSelected = False Then
    With mSelectedRect
        .Left = mX
        .Top = mY
        .Right = mX + IIf(IsHalfChar(mX + 1, mY), 1, 0)
        .Bottom = mY
    End With
End If
With mSelectedRect
    Select Case CopyType
    Case ct_EscText
        ts = GetEscText(.Left, .Top, .Right, .Bottom)
    Case ct_PlainText
        ts = GetPlainText(.Left, .Top, .Right, .Bottom)
    Case ct_Html
        ts = GetHtmlText(.Left, .Top, .Right, .Bottom)
        '//
    End Select
End With
CopyText = ts
End Function

Public Sub Hori_Trans()
Dim X As Long, Y As Long, i As Long, tChar As Byte, tCell As CellType
Dim ts As String, bt() As Byte, ts1 As String, c As String, t As Long
Dim ori_Chars As String
Dim new_Chars As String
ori_Chars = "'/(>]}qtvxz@dJKvݡڡܣۦQ©éĩũƩǩթѩ٩ݩVWX\]^bcd`\)<[{rswy{AgILuܡۡݣݨRȩɩʩ˩̩ͩΩϩ֩ҩکީYZ[_`aefg"
new_Chars = "`\)<[{rswy{AgILuܡۡݣݨRȩɩʩ˩̩ͩΩϩ֩ҩکީYZ[_`aefg'/(>]}qtvxz@dJKvݡڡܣۦQ©éĩũƩǩթѩ٩ݩVWX\]^bcd"
mEditHis.AddStep
With mSelectedRect
    '---/
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    ReDim bt(.Right - .Left)
    For Y = .Top To .Bottom
        CopyMemory bt(0), mChars(.Left, Y), .Right - .Left + 1
        ts = StrConv(bt, vbUnicode)
        ts1 = ""
        For i = Len(ts) To 1 Step -1
            c = Mid(ts, i, 1)
            If gIntelTrans Then
                t = InStr(1, ori_Chars, c)
                If t Then
                    c = Mid(new_Chars, t, 1)
                End If
            End If
            ts1 = ts1 & c
        Next i
        For i = 0 To (.Right - .Left) \ 2
            CopyMemory tCell, mCells(.Left + i, Y), 24&
            CopyMemory mCells(.Left + i, Y), mCells(.Right - i, Y), 24&
            CopyMemory mCells(.Right - i, Y), tCell, 24&
        Next i
        bt = StrConv(ts1, vbFromUnicode)
        CopyMemory mChars(.Left, Y), bt(0), .Right - .Left + 1
    Next Y
End With
If mEditHis.CurStep.IsEmpty Then mEditHis.CancelAddStep
End Sub

Public Sub Vert_Trans()
Dim X As Long, Y As Long, i As Long, tChar As Byte, tCell As CellType
Dim ts As String, bt() As Byte, ts1 As String, c As String, t As Long
Dim ori_Chars As String
Dim new_Chars As String
ori_Chars = "/uޡĨ©ũʩͩթ֩ѩҩީVWXYZ[hijjqsШ@ȡߨJI\ߣߨvŨéƩ˩Ωݩީ٩ک֩\]^_`aklmntr""AɡKL"
new_Chars = "\ߣߨvŨéƩ˩Ωݩީ٩ک֩\]^_`aklmntr""AɡKL/uޡĨ©ũʩͩթ֩ѩҩީVWXYZ[hijjqsШ@ȡߨJI"
'
mEditHis.AddStep
With mSelectedRect
    '---/
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    If gIntelTrans Then
        ReDim bt(.Right - .Left)
        For Y = 0 To .Bottom - .Top
            CopyMemory bt(0), mChars(.Left, .Top + Y), .Right - .Left + 1
            ts = StrConv(bt, vbUnicode)
            ts1 = ""
            For i = 1 To Len(ts)
                c = Mid(ts, i, 1)
                t = InStr(1, ori_Chars, c)
                If t Then
                    c = Mid(new_Chars, t, 1)
                End If
                ts1 = ts1 & c
            Next i
            bt = StrConv(ts1, vbFromUnicode)
            CopyMemory mChars(.Left, .Top + Y), bt(0), .Right - .Left + 1
        Next Y
    End If
    For Y = 0 To (.Bottom - .Top) \ 2
        For X = .Left To .Right
            tChar = mChars(X, .Top + Y)
            mChars(X, .Top + Y) = mChars(X, .Bottom - Y)
            mChars(X, .Bottom - Y) = tChar
            CopyMemory tCell, mCells(X, .Top + Y), 24&
            CopyMemory mCells(X, .Top + Y), mCells(X, .Bottom - Y), 24&
            CopyMemory mCells(X, .Bottom - Y), tCell, 24&
        Next X
    Next Y
End With
If mEditHis.CurStep.IsEmpty Then mEditHis.CancelAddStep
End Sub

Public Sub ReplaceText(OldText As String, NewText As String, MatchCase As Boolean)
Dim X1 As Long, X2 As Long, Y1 As Long, Y2 As Long
Dim X As Long, Y As Long, i As Long, t As Long, ts As String
Dim oCount As Long, nCount As Long, oTs As String, nTs As String, bt() As Byte, bt1() As Byte
Dim tCompType As Long
If mSelected Then
    With mSelectedRect
        X1 = .Left
        Y1 = .Top
        X2 = .Right
        Y2 = .Bottom
    End With
Else
    X1 = 0
    Y1 = 0
    X2 = 80
    Y2 = 24
End If
tCompType = IIf(MatchCase, 0, 1)
oTs = StrConv(OldText, vbFromUnicode)
nTs = StrConv(NewText, vbFromUnicode)
oCount = LenB(oTs)
nCount = LenB(nTs)
ReDim bt(oCount - 1)
If X2 + oCount > 80 Then X2 = 80 - oCount
mEditHis.AddStep
For Y = Y1 To Y2
    For X = X1 To X2 ' - oCount
        CopyMemory bt(0), mChars(X, Y), oCount
        If StrComp(StrConv(bt, vbUnicode), OldText, tCompType) = 0 Then
            '---/
            mEditHis.CurStep.AddCells X, Y, X + nCount - 1, Y
            '---/
            bt1 = nTs
            CopyMemory mChars(X, Y), bt1(0), nCount
            X = X + oCount - 1
        End If
    Next X
Next Y
If mEditHis.CurStep.IsEmpty Then mEditHis.CancelAddStep
End Sub

Public Function IsHalfChar(X As Long, Y As Long) As Boolean
Dim bt() As Byte
Dim t As Long, t1 As Long
If X < 1 Then Exit Function
ReDim bt(X - 1)
t = X
CopyMemory bt(0), mChars(0, Y), t
t1 = Len(StrConv(bt, vbUnicode))
ReDim Preserve bt(t)
bt(t) = mChars(t, Y)
t = Len(StrConv(bt, vbUnicode))
IsHalfChar = (t = t1)
End Function

Public Sub GetAroundChars(ByRef LeftChar As String, ByRef UpChar As String, ByRef RightChar As String, ByRef BelowChar As String)
Dim bt(1) As Byte
On Error Resume Next
If IsHalfChar(mX - 1, mY) Then
    bt(0) = mChars(mX - 2, mY)
    bt(1) = mChars(mX - 1, mY)
    LeftChar = StrConv(bt, vbUnicode)
Else
    LeftChar = Chr(mChars(mX - 1, mY))
End If
'---
If IsHalfChar(mX + 3, mY) Then
    bt(0) = mChars(mX + 2, mY)
    bt(1) = mChars(mX + 3, mY)
    RightChar = StrConv(bt, vbUnicode)
Else
    RightChar = Chr(mChars(mX + 2, mY))
End If
'---
If IsHalfChar(mX + 1, mY - 1) Then
    bt(0) = mChars(mX, mY - 1)
    bt(1) = mChars(mX + 1, mY - 1)
    UpChar = StrConv(bt, vbUnicode)
Else
    UpChar = Chr(mChars(mX, mY - 1))
End If
'---
If IsHalfChar(mX + 1, mY + 1) Then
    bt(0) = mChars(mX, mY + 1)
    bt(1) = mChars(mX + 1, mY + 1)
    BelowChar = StrConv(bt, vbUnicode)
Else
    BelowChar = Chr(mChars(mX, mY + 1))
End If

End Sub


Public Sub PasteHtmlText(ByVal HtmlText As String, Optional ByVal tx As Long = -999, Optional ByVal ty As Long = -999, Optional AddStep As Boolean = True, Optional tx2 As Long, Optional ty2 As Long, Optional PasteType As ePasteTypeEnum = pt_PasteAll)
'zzz
Dim c As String, d As String, s As String, dat As String, v As Long, LL
Dim i As Long, j As Long, t As Long, t1 As Long, t2 As Long, ts As String, ts1 As String, tarr As Variant
Dim b As Byte, xx As Long, yy As Long, bt() As Byte, LineTs As String
Dim EscStartIdx As Long, BlankEscStr As Boolean, AbandonCount As Long, ResetAttr As Boolean
Dim cHtmlColors As New Collection, cHtmlFonts As New Collection
'---
With cHtmlColors
    .Add 0, "#000000"
    .Add 1, "#800000"
    .Add 2, "#008000"
    .Add 3, "#808000"
    .Add 4, "#000080"
    .Add 5, "#800080"
    .Add 6, "#008080"
    .Add 7, "#c0c0c0"
    .Add 8, "#808080"
    .Add 9, "#ff0000"
    .Add 10, "#00ff00"
    .Add 11, "#ffff00"
    .Add 12, "#0000ff"
    .Add 13, "#ff00ff"
    .Add 14, "#00ffff"
    .Add 15, "#FFFFFF"
End With
With cHtmlFonts
.Add 0, ""
.Add 2, ""
.Add 3, ""
End With
Dim parseBack As Boolean, parseFore As Boolean
Select Case PasteType
    Case pt_PasteAll
        parseBack = True
        parseFore = True
    Case pt_PasteNoBackAndForeGround
    Case pt_PasteNoBackGround
        parseFore = True
    Case pt_PasteNoForeGround
        parseBack = True
End Select
'---
Dim txtLen  As Long, mi As Long, tCell As CellType, curX As Long, curY As Long, MaxX As Long
On Error Resume Next
t = InStr(1, HtmlText, "<td nowrap>")
If t Then HtmlText = Mid(HtmlText, t + 11)
t = InStr(1, HtmlText, "</td></tr></table>")
If t Then HtmlText = Left(HtmlText, t - 1)
HtmlText = Replace(HtmlText, " ", "")
HtmlText = Replace(HtmlText, vbCr, "")
HtmlText = Replace(HtmlText, vbLf, "")
HtmlText = Replace(HtmlText, vbTab, "")
HtmlText = Replace(HtmlText, "&nbsp;", Chr(8))
HtmlText = Replace(HtmlText, "&lt;", Chr(9))

If tx = -999 Then tx = mX
If ty = -999 Then ty = mY
txtLen = Len(HtmlText)
curX = tx
curY = ty
'---/
If AddStep Then mEditHis.AddStep
'---/
CopyMemory tCell, mCells(tx, ty), 24&
With tCell
    If parseFore Then
        .Blink = False
        .FontIndex = 0
        .ForeGround = 37
        .HighLight = 1
        .Reverse = False
        .UnderLine = False
    End If
    If parseBack Then
        .BackGround = 40
    End If
End With
For mi = 1 To txtLen
    c = Mid(HtmlText, mi, 1)
    Select Case c
    Case "<"
        t = InStr(mi, HtmlText, ">")
        If t Then
            ts = Mid(HtmlText, mi + 1, t - mi - 1)
            Select Case ts
                Case "br"
                    LineTs = Replace(LineTs, Chr(8), " ")
                    LineTs = Replace(LineTs, Chr(9), "<")
                    bt = StrConv(LineTs, vbFromUnicode)
                    t1 = 80 - tx
                    t2 = UBound(bt) + 1
                    If t2 > t1 Then t2 = t1
                    If t2 Then CopyMemory mChars(tx, curY), bt(0), t2
                    CopyMemory tCell, stdCell, 24&
                    LineTs = ""
                    curX = tx
                    curY = curY + 1
                Case "blink"
                    tCell.Blink = True
                Case "/blink"
                    tCell.Blink = False
                Case Else
                    t1 = InStr(1, ts, "background-color:")
                    If t1 Then
                        ts1 = Mid(ts, t1 + 17, 7)
                        tCell.BackGround = 40 + cHtmlColors(ts1)
                        'Debug.Print "background: " & ts1 & "~~~~~~"
                        ts1 = Mid(ts, t1 + 31, 7)
                        t2 = cHtmlColors(ts1)
                        'Debug.Print "foreground: " & ts1 & "~~~~~~"
                        If t2 > 7 Then
                            tCell.ForeGround = 30 + t2 - 8
                            tCell.HighLight = 1
                        Else
                            tCell.ForeGround = 30 + t2
                            tCell.HighLight = 0
                        End If
                        ts1 = Mid(ts, t1 + 51, 2)
                        tCell.FontIndex = cHtmlFonts(ts1)
                        'Debug.Print "fontindex: " & ts1 & "~~~~~~"
                        ts1 = Mid(ts, t1 + 70, 4)
                        'Debug.Print "underline: " & ts1 & "~~~~~~"
                        tCell.UnderLine = (ts1 = "unde")
                    End If
            End Select
            mi = t
        Else
            mi = 65535
        End If
    Case Else
        '---/
        mEditHis.CurStep.AddCell curX, curY
        '---/
        t = LenB(StrConv(c, vbFromUnicode))
        CopyMemory mCells(curX, curY), tCell, 24&
        If t = 2 Then
            '---/
            mEditHis.CurStep.AddCell curX + 1, curY
            '---/
            CopyMemory mCells(curX + 1, curY), tCell, 24&
        End If
        curX = curX + t
        LineTs = LineTs & c
    End Select
L2:
    If curY > 23 Then Exit For
Next mi
If mi = 65535 Then
    LineTs = Replace(LineTs, Chr(8), " ")
    LineTs = Replace(LineTs, Chr(9), "<")
    bt = StrConv(LineTs, vbFromUnicode)
    t1 = 80 - tx
    t2 = UBound(bt) + 1
    If t2 > t1 Then t2 = t1
    CopyMemory mChars(tx, curY), bt(0), t2
End If
mX = curX
mY = curY
'Dim tTimer2Enabled As Boolean
'tTimer2Enabled = Timer2.Enabled
'If tTimer2Enabled Then HideCaret
ReRenderScreen
'If tTimer2Enabled Then ShowCaret
tx2 = MaxX
ty2 = curY
If tx2 > 80 Then tx2 = 80
If ty2 > 23 Then ty2 = 23
End Sub


'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=     괦    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Public Sub GotoXY(X As Long, Y As Long)
Dim oldmx As Long
oldmx = mX
mX = X - 1
mY = Y - 1
If IsHalfChar(mX, mY) Then mX = mX + 1 * IIf(mX < oldmx, -1, 1)
SetCaretPosition mCellWidth * mX, mCellHeight * (mY + 1)
End Sub

Public Sub GotoX(X As Long)
mX = X - 1
End Sub

Public Sub GotoY(Y As Long)
mY = Y - 1
End Sub

Public Sub SaveXY()
mSavedX = mX
mSavedY = mY
End Sub

Public Sub RestoreXY()
mX = mSavedX
mY = mSavedY
End Sub

Public Sub MoveUp(n As Long)
mY = mY - n
End Sub

Public Sub MoveDown(n As Long)
mY = mY + n
End Sub

Public Sub MoveLeft(n As Long)
mX = mX - n
If mX < 0 Then mX = 0
End Sub

Public Sub MoveRight(n As Long)
mX = mX + n
If mX > 81 Then mX = 80
If IsHalfChar(mX, mY) Then mX = mX + 1
End Sub

Private Sub SetCaretPosition(X As Long, Y As Long)
'If mCaretShown And Timer2.Enabled Then InvertRect UserControl.hDC, mCaretRect
If mCaretCount Mod 2 Then Timer2_Timer
With mCaretRect
    .Left = X
    .Right = X + mCellWidth
    .Top = Y - mCellHeight
    .Bottom = Y
End With
Timer2_Timer
'InvertRect UserControl.hDC, mCaretRect
'mCaretShown = False
'If Timer2.Enabled Then Timer2_Timer
End Sub

Private Sub Timer2_Timer()
'If mSelecting Or mSelected Then Exit Sub
InvertRect UserControl.hDC, mCaretRect
'mCaretShown = Not mCaretShown
mCaretCount = mCaretCount + 1
If mCaretCount > 65535 Then mCaretCount = 0   'żʱΪ(mCaretCount0)
If MoveBox.Visible Then MoveBox.Refresh
End Sub

'Public Sub HideCaret()
'Timer2.Enabled = False
'If mCaretShown Then Timer2_Timer
'End Sub
'
'Public Sub ShowCaret()
''SetCaretPosition mCellWidth * mX, mCellHeight * (mY + 1)
''If Not mCaretShown Then Timer2_Timer
''mCaretShown = False
''Timer2_Timer
'Timer2.Enabled = True
'End Sub

Public Property Get CurrentX() As Long
CurrentX = mX
End Property

Public Property Get CurrentY() As Long
CurrentY = mY
End Property

Public Sub SetToolCursor()
On Error Resume Next
If gCurTool = NoTool Then
    UserControl.MousePointer = 0
Else
    UserControl.MousePointer = 99
    Select Case gCurTool
    Case FloodTool
        UserControl.MouseIcon = gcCursors("flood")
    Case ColorPickerTool
        Set UserControl.MouseIcon = gcCursors("colorpicker")
    Case StampTool
        UserControl.MouseIcon = gcCursors("stamp")
    Case RubberTool
        UserControl.MouseIcon = gcCursors("rubber")
    Case FormatBrushTool
        UserControl.MouseIcon = gcCursors("formatbrush")
    End Select
End If
End Sub

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=         -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=



Public Sub ReRenderScreen()
'Dim tTimer2Enabled As Boolean
'tTimer2Enabled = Timer2.Enabled
'If tTimer2Enabled Then HideCaret
Dim r As RECT
With r
    .Right = 1024
    .Bottom = 768
End With
FillRect UserControl.hDC, r, bgHBrush
ReRenderRegion 0, 0, 80, 23
'If tTimer2Enabled Then ShowCaret
End Sub

Private Sub ShowBlinkText()
Dim X1 As Long, Y1 As Long, X2 As Long, Y2 As Long
X1 = 0
Y1 = 0
X2 = 80
Y2 = 23
SetBkMode UserControl.hDC, 1
Dim i  As Long, j As Long, t As Long, ts As String, t1 As Long
Dim bts(81) As Byte, tx As Long, ty As Long, ct1 As Long, tForeColor As Long
Dim ShowBlink As Boolean
Dim b As Boolean, b1 As Boolean, r As Boolean, r1 As Boolean, h As Long, h1 As Long
Dim bTmp As Boolean
Dim f As Long, f1 As Long, bk As Long, bk1 As Long, u As Boolean, u1 As Boolean, s As Boolean, s1 As Boolean, fi As Long, fi1 As Long
Dim nCount As Long, tCell As CellType
CopyMemory tCell, mCell, 24
LoadCellAttributes1 X1, Y1
With mCells(X1, Y1)
    b = .Blink
    r = .Reverse
    h = .HighLight
    f = .ForeGround
    bk = .BackGround
    fi = .FontIndex
End With
For i = Y1 To Y2
    t = X1
    u = mCells(X1, i).UnderLine
    For j = X1 To X2
        With mCells(j, i)
            b1 = .Blink
            r1 = .Reverse
            h1 = .HighLight
            f1 = .ForeGround
            bk1 = .BackGround
            u1 = .UnderLine
            fi1 = .FontIndex
        End With
        s1 = mSelectedCells(j, i)
        
        If b1 <> b Or r1 <> r Or h1 <> h Or f1 <> f Or bk1 <> bk Or u <> u1 Or s1 <> s Or fi <> fi1 Then
            b = b1
            r = r1
            h = h1
            f = f1
            bk = bk1
            fi = fi1
            ts = StrConv(MidB(bts, t + 1, j - t), vbUnicode)
            If mBlinkDown Then LoadCellAttributes1 t, i Else LoadCellAttributes t, i
            tx = t * mCellWidth
            ty = mCellHeight * i
            nCount = j - t
            If mCells(t, i).Blink Then TextOut UserControl.hDC, tx, ty, ts, nCount
            If u Then
                t1 = ty + mCellHeight - 1
                MoveTo UserControl.hDC, tx, t1, ByVal 0&
                LineTo UserControl.hDC, tx + mCellWidth * nCount, t1
            End If
            u = u1
            t = j
            s = s1
        End If
        bts(j) = mChars(j, i)
        If bts(j) = 0 Then bts(j) = 32
    Next j
    If mBlinkDown Then LoadCellAttributes1 t, i Else LoadCellAttributes t, i '+ 1
    ts = StrConv(MidB(bts, t + 1, X2 - t), vbUnicode)
    tx = t * mCellWidth
    ty = mCellHeight * i
    If mCells(t, i).Blink Then TextOut UserControl.hDC, tx, ty, ts, X2 - t
Next i
CopyMemory mCell, tCell, 24
SetBkMode UserControl.hDC, 2
mColorChanged = True
If MoveBox.Visible Then MoveBox.Refresh
End Sub

Public Sub TransOutText(ByRef bts() As Byte, ByVal nCount As Long)
    On Error GoTo kkk
    If nCount = 0 Then Exit Sub
    Dim tx As Long, ty As Long
    Dim ts As String, i As Long, t As Long
    'If mColorChanged Then UpdateColorAttributes  'zzz
'    tx = mCellWidth * mX
'    ty = mCellHeight * mY
    ts = StrConv(LeftB(bts, nCount), vbUnicode)
'    TextOut UserControl.hDC, tx, ty, ts, nCount
'    If mCell.UnderLine Then
'        i = ty + mCellHeight - 1
'        MoveTo UserControl.hDC, tx, i, ByVal 0&
'        LineTo UserControl.hDC, tx + mCellWidth * nCount, i
'    End If
    If nCount + mX > 80 Then nCount = 80 - mX
    For i = 0 To nCount - 1
        If Not TransBackColor Then
            mCells(mX + i, mY).BackGround = mCell.BackGround
        End If
        If Not TransForeColor Then
            mCells(mX + i, mY).ForeGround = mCell.ForeGround
            mCells(mX + i, mY).HighLight = mCell.HighLight
        End If
        mCells(mX + i, mY).Blink = mCell.Blink
        mCells(mX + i, mY).FontIndex = mCell.FontIndex
        mCells(mX + i, mY).UnderLine = mCell.UnderLine
        mCells(mX + i, mY).Reverse = mCell.Reverse
        If bts(i) > 127 Then
            CopyMemory mCells(mX + i + 1, mY), mCells(mX + i, mY), 24
            i = i + 1
        End If
    Next i
    CopyMemory mChars(mX, mY), bts(0), nCount
    ReRenderRegion 0, mY, 80, mY
    mX = mX + nCount
    Exit Sub
kkk:
    Debug.Print "err!!!!!!!!! " & mX & "," & mY & ": " & ts
    Debug.Print "err in TransOutText: " & Err.Description
End Sub

Public Sub OutText(ByRef bts() As Byte, ByVal nCount As Long, Optional vertTextOut As Boolean = False)
    On Error GoTo kkk
    If nCount = 0 Then Exit Sub
    Dim tx As Long, ty As Long
    Dim ts As String, i As Long, t As Long
    If mColorChanged Then UpdateColorAttributes  'zzz
    '----------------------------------------------
    If TransForeColor Or TransBackColor Then
        TransOutText bts, nCount
        Exit Sub
    End If
    'If mCaretShown Then InvertRect UserControl.hDC, mCaretRect: mCaretShown = False
    mCaretCount = 0
    'mCaretShown = False
    '----------------------------------------------
    tx = mCellWidth * mX
    ty = mCellHeight * mY
'===
    If nCount + mX > 80 Then nCount = 80 - mX
    ts = StrConv(LeftB(bts, nCount), vbUnicode)
    If gInsertMode Then '//zzz
        '---/
        mEditHis.AddStep
        mEditHis.CurStep.AddCells mX, mY, 81, mY
        '---/
        t = mX + nCount
        MoveMemory mCells(t, mY), mCells(mX, mY), (81 - t + 1) * 24&
        MoveMemory mChars(t, mY), mChars(mX, mY), 255 - t + 1
        For i = 0 To nCount - 1
            CopyMemory mCells(mX + i, mY), mCell, 24&
        Next i
        CopyMemory mChars(mX, mY), bts(0), nCount
        ReRenderRegion mX, mY, 80, mY
    Else
        TextOut UserControl.hDC, tx, ty, ts, nCount
        If mCell.UnderLine Then
            i = ty + mCellHeight - 1
            MoveTo UserControl.hDC, tx, i, ByVal 0&
            LineTo UserControl.hDC, tx + mCellWidth * nCount, i
        End If
        '---/
        mEditHis.AddStep
        mEditHis.CurStep.AddCells mX, mY, mX + nCount - 1, mY
        '---/
        For i = 0 To nCount - 1
            CopyMemory mCells(mX + i, mY), mCell, 24
        Next i
        CopyMemory mChars(mX, mY), bts(0), nCount
    End If
    gLastChar = Right(ts, 1)
    If mShowGrid Then DrawGrid 0, mY, 80, mY
    If vertTextOut Then
        mY = mY + 1
        If mY > 23 Then
            If mX > 78 Then
                mY = 23
            Else
                mX = mX + 1
                mY = 0
            End If
        End If
    Else
        mX = mX + nCount
        If mX > 79 Then
            If mY > 22 Then
                mX = 79
            Else
                mX = 0
                mY = mY + 1
            End If
        End If
    End If
    'SetCaretPos mX + 2, mY
    SetCaretPosition mCellWidth * mX, mCellHeight * (mY + 1)
    Exit Sub
kkk:
    Debug.Print "err!!!!!!!!! " & mX & "," & mY & ": " & ts
    Debug.Print "err in OutText: " & Err.Description
End Sub

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=     CellԴ    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


Public Property Let ForeGround(NewForeGround As Long)
mCell.ForeGround = NewForeGround
mColorChanged = True
End Property

Public Property Let BackGround(NewBackGround As Long)
mCell.BackGround = NewBackGround
mColorChanged = True
End Property

Public Property Let HighLight(NewHighLight As Long)
mCell.HighLight = NewHighLight
mColorChanged = True
End Property

Public Property Let Reverse(NewReverse As Boolean)
mCell.Reverse = NewReverse
mColorChanged = True
End Property

Public Property Let Blink(NewBlink As Boolean)
mCell.Blink = NewBlink
mColorChanged = True
End Property

Public Property Let UnderLine(NewUnderLine As Boolean)
mCell.UnderLine = NewUnderLine
mColorChanged = True
End Property

Public Property Let FontIndex(NewFontIndex As Long)
On Error GoTo kkk
If NewFontIndex > 3 Or NewFontIndex = mFontIndex Then Exit Property
mFontIndex = NewFontIndex
Dim tLF As Long
UserControl.FontName = gFontNames(NewFontIndex)
mCell.FontIndex = NewFontIndex
kkk:
Debug.Print "FontIndex=" & NewFontIndex & "  !! " & gFontNames(NewFontIndex)
End Property

Private Sub LoadCellAttributes1(X As Long, Y As Long)
If mCells(X, Y).ForeGround = 0 Then CopyMemory mCells(X, Y), stdCell, 24
CopyMemory mCell, mCells(X, Y), 24
If mSelectedCells(X, Y) Then
    With mCell
        .ForeGround = 30
        .BackGround = 47
        .Reverse = False
    End With
End If
UpdateColorAttributes1
End Sub

Private Sub UpdateColorAttributes1()
On Error Resume Next
With mCell
    If .Reverse Then
        mBackColor = gColors(.ForeGround - 30)
        SetTextColor UserControl.hDC, mBackColor
    Else
        mBackColor = gColors(.BackGround - 40)
        SetTextColor UserControl.hDC, mBackColor
    End If
    If UserControl.FontName <> gFontNames(.FontIndex) Then UserControl.FontName = gFontNames(.FontIndex)
End With
mColorChanged = False
End Sub

Private Sub LoadCellAttributes(X As Long, Y As Long)
If mCells(X, Y).ForeGround = 0 Then CopyMemory mCells(X, Y), stdCell, 24
CopyMemory mCell, mCells(X, Y), 24
If mSelectedCells(X, Y) Then
    With mCell
        .ForeGround = 30
        .BackGround = 47
        .Reverse = False
    End With
End If
UpdateColorAttributes
End Sub

Private Sub UpdateColorAttributes()
On Error Resume Next
With mCell
    If .Reverse Then
        mBackColor = gColors(.ForeGround - 30)
        SetBkColor UserControl.hDC, mBackColor
        mForeColor = gColors(.BackGround - 40 + 8 * .HighLight)
        SetTextColor UserControl.hDC, mForeColor
    Else
        mBackColor = gColors(.BackGround - 40)
        SetBkColor UserControl.hDC, mBackColor
        mForeColor = gColors(.ForeGround - 30 + 8 * .HighLight)
        SetTextColor UserControl.hDC, mForeColor
    End If
    If UserControl.FontName <> gFontNames(.FontIndex) Then UserControl.FontName = gFontNames(.FontIndex)
End With
mColorChanged = False
End Sub

Private Sub LoadAttributesFromCell(Cell As CellType)
With Cell
    If .Reverse Then
        mBackColor = gColors(.ForeGround - 30)
        mForeColor = gColors(.BackGround - 40 + 8 * .HighLight)
    Else
        mBackColor = gColors(.BackGround - 40)
        mForeColor = gColors(.ForeGround - 30 + 8 * .HighLight)
    End If
End With
SetBkColor UserControl.hDC, mBackColor
SetTextColor UserControl.hDC, mForeColor
End Sub

Private Function LoadCellAttributesForHtml(X As Long, Y As Long) As String
Dim tForeColor As Long, tBackColor As Long
Dim tForeGround As Long, tBackGround As Long, tFontIndex As Long, tUnderLine As Boolean
Dim tHighLight As Long, tReverse As Boolean, tBlink As Boolean
Dim ts As String

With mCells(X, Y)
    tForeGround = .ForeGround
    tBackGround = .BackGround
    tHighLight = .HighLight
    tReverse = .Reverse
    tBlink = .Blink
    tUnderLine = .UnderLine
    tFontIndex = .FontIndex
    If tForeGround = 0 Then tForeGround = 37
    If tBackGround = 0 Then tBackGround = 40
End With
If tReverse Then
    tBackColor = tForeGround - 30
    tForeColor = tBackGround - 40 + 8 * tHighLight
Else
    tBackColor = tBackGround - 40
    tForeColor = tForeGround - 30 + 8 * tHighLight
End If
ts = IIf(mHtmlBlink, "</blink>", "") & "</span><span style=""background-color:" & _
     gHtmlColors(tBackColor) & ";color:" & gHtmlColors(tForeColor) & ";font-family:" & _
     gFontNames(tFontIndex) & IIf(tUnderLine, ";text-decoration:underline", ";text-decoration:none") & ";"">" & IIf(tBlink, "<blink>", "")
mHtmlBlink = tBlink
LoadCellAttributesForHtml = ts
End Function

Public Sub SetSelectedForeGround(ByVal NewForeGround As Long)
Dim X As Long, Y As Long
With mSelectedRect
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    For Y = .Top To .Bottom
        For X = .Left To .Right
            mCells(X, Y).ForeGround = NewForeGround
        Next X
    Next Y
End With
End Sub

Public Sub SetSelectedBackGround(ByVal NewBackGround As Long)
Dim X As Long, Y As Long
With mSelectedRect
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    For Y = .Top To .Bottom
        For X = .Left To .Right
            mCells(X, Y).BackGround = NewBackGround
        Next X
    Next Y
End With
End Sub

Public Sub SetSelectedHighLight(ByVal NewHighLight As Long)
Dim X As Long, Y As Long
With mSelectedRect
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    For Y = .Top To .Bottom
        For X = .Left To .Right
            mCells(X, Y).HighLight = NewHighLight
        Next X
    Next Y
End With
End Sub

Public Sub SetSelectedBlink(ByVal NewBlink As Boolean)
Dim X As Long, Y As Long
With mSelectedRect
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    For Y = .Top To .Bottom
        For X = .Left To .Right
            mCells(X, Y).Blink = NewBlink
        Next X
    Next Y
End With
End Sub

Public Sub SetSelectedReverse(ByVal NewReverse As Boolean)
Dim X As Long, Y As Long
With mSelectedRect
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    For Y = .Top To .Bottom
        For X = .Left To .Right
            mCells(X, Y).Reverse = NewReverse
        Next X
    Next Y
End With
End Sub

Public Sub SetSelectedUnderLine(ByVal NewUnderLine As Boolean)
Dim X As Long, Y As Long
With mSelectedRect
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    For Y = .Top To .Bottom
        For X = .Left To .Right
            mCells(X, Y).UnderLine = NewUnderLine
        Next X
    Next Y
End With
End Sub

Public Sub SetSelectedFontIndex(ByVal NewFontIndex As Long)
Dim X As Long, Y As Long
With mSelectedRect
    '---/
    mEditHis.AddStep
    mEditHis.CurStep.AddCells .Left, .Top, .Right, .Bottom
    '---/
    For Y = .Top To .Bottom
        For X = .Left To .Right
            mCells(X, Y).FontIndex = NewFontIndex
        Next X
    Next Y
End With
End Sub

Private Sub FloodFill(X As Long, Y As Long)
On Error GoTo kkk
Dim tx As Long, ty As Long, tBackGround As Long
If X < 0 Or Y < 0 Or X > 80 Or Y > 23 Then Exit Sub
tBackGround = mCells(X, Y).BackGround
If tBackGround = mCell.BackGround Then Exit Sub
'---/
mEditHis.CurStep.AddCell X, Y
'---/
mCells(X, Y).BackGround = mCell.BackGround
If mCells(X - 1, Y).BackGround = tBackGround Then FloodFill X - 1, Y
If mCells(X + 1, Y).BackGround = tBackGround Then FloodFill X + 1, Y
If mCells(X, Y - 1).BackGround = tBackGround Then FloodFill X, Y - 1
If mCells(X, Y + 1).BackGround = tBackGround Then FloodFill X, Y + 1
kkk:
End Sub

Private Sub ResetCells(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long)
Dim X As Long, Y As Long
For Y = Y1 To Y2
    For X = X1 To X2
        CopyMemory mCells(X, Y), stdCell, 24&
    Next X
Next Y
End Sub

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=     ʷ¼    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Private Sub mEditHis_HistoryChanged(HistoryState As HistoryState)
RaiseEvent HistoryChanged(HistoryState)
End Sub

Public Sub Undo()
mEditHis.Undo
ReRenderScreen
End Sub

Public Sub Redo()
mEditHis.Redo
ReRenderScreen
End Sub

Public Sub ClearHistory()
mEditHis.ClearHistory
mLastStepCount = 0
End Sub

Public Property Get FileChanged() As Boolean
FileChanged = ((mEditHis.CurStepNumber + 1) And (mEditHis.StepCount <> mLastStepCount))
End Property

Public Property Let FileChanged(NewFileChanged As Boolean)
If NewFileChanged Then
    mLastStepCount = 0
Else
    mLastStepCount = mEditHis.StepCount
End If
End Property

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Sub ReRenderSelected()
With mSelectedRect
    ReRenderRegion 0, .Top, 81, .Bottom
    'ReRenderScreen ' 0, 0, 80, 24
End With
End Sub

Public Property Get CellWidth() As Long
CellWidth = mCellWidth
End Property

Public Property Get CellHeight() As Long
CellHeight = mCellHeight
End Property


Public Sub ReRenderRegion(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long)
Dim i  As Long, j As Long, t As Long, ts As String, t1 As Long
Dim bts(81) As Byte, tx As Long, ty As Long, ct1 As Long, tForeColor As Long
Dim ShowBlink As Boolean
Dim b As Boolean, b1 As Boolean, r As Boolean, r1 As Boolean, h As Long, h1 As Long
Dim bTmp As Boolean
Dim f As Long, f1 As Long, bk As Long, bk1 As Long, u As Boolean, u1 As Boolean, s As Boolean, s1 As Boolean, fi As Long, fi1 As Long
Dim nCount As Long, tCell As CellType
'Dim tTimer2Enabled As Boolean
If mCaretCount Mod 2 Then Timer2_Timer
If mX >= X1 And mX <= X2 And mY >= Y1 And mY <= Y2 Then mCaretCount = 0
'tTimer2Enabled = Timer2.Enabled
'If tTimer2Enabled Then HideCaret
CopyMemory tCell, mCell, 24
LoadCellAttributes X1, Y1
With mCells(X1, Y1)
    b = .Blink
    r = .Reverse
    h = .HighLight
    f = .ForeGround
    bk = .BackGround
    fi = .FontIndex
End With
For i = Y1 To Y2
    t = X1
    u = mCells(X1, i).UnderLine
    For j = X1 To X2
ContinueJ:
        With mCells(j, i)
            b1 = .Blink
            r1 = .Reverse
            h1 = .HighLight
            f1 = .ForeGround
            bk1 = .BackGround
            u1 = .UnderLine
            fi1 = .FontIndex
        End With
        s1 = mSelectedCells(j, i)
        
        If b1 <> b Or r1 <> r Or h1 <> h Or f1 <> f Or bk1 <> bk Or u <> u1 Or s1 <> s Or fi <> fi1 Then
            If IsHalfChar(j, i) Then
                CopyMemory mCells(j, i), mCells(j - 1, i), 24&
                mSelectedCells(j, i) = mSelectedCells(j - 1, i)
                GoTo ContinueJ
            End If
            b = b1
            r = r1
            h = h1
            f = f1
            bk = bk1
            fi = fi1
            ts = StrConv(MidB(bts, t + 1, j - t), vbUnicode)
            LoadCellAttributes t, i
            tx = t * mCellWidth
            ty = mCellHeight * i
            nCount = j - t
            TextOut UserControl.hDC, tx, ty, ts, nCount
            If u Then
                t1 = ty + mCellHeight - 1
                MoveTo UserControl.hDC, tx, t1, ByVal 0&
                LineTo UserControl.hDC, tx + mCellWidth * nCount, t1
            End If
            u = u1
            t = j
            s = s1
        End If
        bts(j) = mChars(j, i)
        If bts(j) = 0 Then bts(j) = 32
    Next j
    LoadCellAttributes t, i '+ 1
    ts = StrConv(MidB(bts, t + 1, X2 - t), vbUnicode)
    TextOut UserControl.hDC, t * mCellWidth, mCellHeight * i, ts, X2 - t
Next i
CopyMemory mCell, tCell, 24
mColorChanged = True
If mShowGrid Then DrawGrid X1, Y1, X2, Y2
If mSelected Then
    With mSelectedRect
        UserControl.DrawStyle = 2
        Rectangle UserControl.hDC, .Left * mCellWidth, .Top * mCellHeight, (.Right + 1) * mCellWidth, (.Bottom + 1) * mCellHeight
        UserControl.DrawStyle = 0
    End With
End If
'Debug.Print "RerenderRegion ! " & Now
'If tTimer2Enabled Then ShowCaret
'If Timer2.Enabled Then Timer2_Timer
If MoveBox.Visible Then MoveBox.Refresh
'frmMain.Caption = "Render OK " & Now
End Sub
