Attribute VB_Name = "modProgressBar"
Private Const PROGRESS_CLASS = "msctls_progress32"
Private Const PBS_SMOOTH = &H1 ' IE3 and later
Private Const PBS_VERTICAL = &H4 ' IE3 and later
Private Const WS_VISIBLE = &H10000000
Private Const WS_CHILD = &H40000000
Private Const WM_USER = &H400

Public Const PBM_SETRANGE = (WM_USER + 1)
Public Const PBM_SETPOS = (WM_USER + 2)
Private Const PBM_DELTAPOS = (WM_USER + 3)
Public Const PBM_SETSTEP = (WM_USER + 4)
Private Const PBM_STEPIT = (WM_USER + 5)
Private Const PBM_SETRANGE32 = (WM_USER + 6)
Private Const PBM_GETRANGE = (WM_USER + 7)
Private Type PPBRANGE
    iLow As Long
    iHigh As Long
End Type
Private Const PBM_GETPOS = (WM_USER + 8)

Private Const ICC_LISTVIEW_CLASSES = &H1 ' // listview, header
Private Const ICC_TREEVIEW_CLASSES = &H2 ' // treeview, tooltips
Private Const ICC_BAR_CLASSES = &H4 ' // toolbar, statusbar, trackbar, tooltips
Private Const ICC_TAB_CLASSES = &H8 ' // tab, tooltips
Private Const ICC_UPDOWN_CLASS = &H10 ' // updown
Private Const ICC_PROGRESS_CLASS = &H20 ' // progress
Private Const ICC_HOTKEY_CLASS = &H40 ' // hotkey
Private Const ICC_ANIMATE_CLASS = &H80 ' // animate
Private Const ICC_WIN95_CLASSES = &HFF ' loads everything above
Private Const ICC_DATE_CLASSES = &H100 ' // month picker, date picker, time picker, updown
Private Const ICC_USEREX_CLASSES = &H200 ' // comboex
Private Const ICC_COOL_CLASSES = &H400 ' // rebar (coolbar) control
Public Function CreateProgressBar(ByVal parentHwnd As Long) As Long
Dim icc As tagINITCOMMONCONTROLSEX
icc.dwSize = Len(icc)
icc.dwICC = ICC_PROGRESS_CLASS
CreateProgressBar = CreateWindowEx(0, PROGRESS_CLASS, vbNullString, WS_CHILD Or WS_VISIBLE Or IIf(chkSmooth, PBS_SMOOTH, 0) Or IIf(chkVertical, PBS_VERTICAL, 0), 0, 0, 0, 0, parentHwnd, 0, App.hInstance, ByVal 0)
End Function

Public Sub SetProgressBarValue(ByVal ProgressBarHwn As Long, Value As Long)
SendMessage ProgressBarHwn, PBM_SETPOS, ByVal Value, 0
End Sub

